<%@ page errorPage="/CCM/ErrorPage.jsp" import="java.util.Vector"%>
<jsp:useBean id="ProblemListBean" class="ccm.at.ProblemListBean" scope="page">
  <jsp:setProperty name="ProblemListBean" property="userName" 
   value="<%=request.getRemoteUser()%>"/>
  <jsp:setProperty name="ProblemListBean" property="usersDir" 
   value="/usr/local/apache_t3.1/htdocs/SciPortal/WEB-INF/Descriptors/users"/>
</jsp:useBean>
<html>
<head>
  <link rel="stylesheet" type="text/css" href="/SciPortal/styles/standard.css">
  <script language="javascript" src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="Keywords" content="OSC SciPortal">
  <meta http-equiv="Descriptions" content="CCM - AT">	
  <title>
    Analysis Toolkit
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<h1 class="bdr">
List of Existing Problems
</h1>
<div class="right">
  <form class="NAV" name="helpform">
    <input type="button" name="submit" value="help"
      onClick="showHelp('/SciPortal/CCM/AT/ASSISTANTPAGES/AThelp.html');">
  </form>
</div>
<table border="2">
  <caption>
    Select the desired analysis 
  </caption>
  <tr>
    <th>
      Problem name
    </th>
    <th colspan="2">
      Available analysis techniques (2D plots)
    </th>
  </tr>
<% 
  Vector problemNames = ProblemListBean.getProblemNames();
  for (int i = 0; i < problemNames.size(); i++) {
     String pName = ((String)problemNames.get(i)).trim();
%>
  <tr>
    <td>
<%       
     out.print(pName); 
%> 
    </td><td>
      <a href="<%=pName%>-SCF.html">
        Quick convergence check
      </a>
    </td><td>
      <a href="<%=pName%>-OE.html">
        Orbital Energies
      </a>
    </td>
  </tr>
<%  
   } 
%>
</table>
</body>
</html>
