<%@ page info="SciPortal Entry Page" %>
<%@ page errorPage="/Entry/ErrorPage.jsp" %>
<% 
  String UID = request.getRemoteUser();
  if(UID == null) UID = "ST"; 
  String userName = "Captain Dunsel";
  boolean pstatus = false;
  String ustatus = "";
  String rootDir = application.getRealPath("/");
%>
<jsp:useBean id="entry" scope="page" class="entry.EntryBean" />
<jsp:setProperty name="entry" property="user" value="<%=UID%>" />
<jsp:setProperty name="entry" property="documentRoot" value="<%=rootDir%>" />
<html>
<head>
  <meta http-equiv="Content-Style-Type" content="text/css">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="Keywords" content="OSC - SciPortal">
  <meta http-equiv="Descriptions" content="Entry">
  <title>
    SciPortal Welcome Page for <%=UID%>
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">
<jsp:include page="/Entry/Copyright.html" flush="true" />
<h1 class="bdr">
  <div class="center">
    The OSC SciPortal
    <br />Welcome Page
  </div>
</h1>
<table border="0" cellspacing="20">
<tr>
  <td valign="top" align="center">
    <span style="font-size:14pt;">Welcome</span>
    <span style="color:brown; font-weight:bold; font-size:14pt;">
    <%
      userName = entry.getUserName();
      out.println(userName);
      pstatus = entry.makeProfile();
    %>
    </span>.
    <br />
    &nbsp;&nbsp;&nbsp;&nbsp;
    <span style="color:red; font-weight:bold; font-size:12pt;">
    <br /><br />
    The current date and time is <script src="/SciPortal/js/todayDate.js"></script>
    </span>
    <p>
    The navigation buttons along the top allow you to select your next step.
    </p>
  </td>
</tr><tr>
  <td valign="top" align="right">
    <span style="color:brown; font-weight:bold; font-size:10pt;">
    Note: &nbsp;&nbsp;
    <%
      ustatus = entry.makeUserFile();
      out.println(ustatus);
    %>
    </span>
  </td>
</tr><tr>
  <td>
    <% if(pstatus){ %>
    <p>
    <form name="profileView" method="get" action="entryHandler.jsp">
      <input type="submit" class="NAV" name="option" value="view">
        <span style="font-size:14pt;">To view your current profile, 
        click the view button.</span>
      </input>
    </form>
    </p>
    <% } else { %>
    <p>
    Error generating the user profile, contact the 
    <span class="sP">SciPortal</span> administrator.
    </p>
    <% } %>
  </td>
</tr>
</table>
</body>
</html>
