<%@ page errorPage="/Test/ErrorPage.jsp" %>
<% 
  String UID = request.getRemoteUser(); 
  if(UID == null) UID = "ST";
  String userName = "Captain Dunsel";
  String rootDir = application.getRealPath("/");
  String track, problemDescriptionName;
%>
<jsp:useBean id="entry" scope="page" class="entry.EntryBean" />
<jsp:setProperty name="entry" property="user" value="<%=UID%>" />
<jsp:setProperty name="entry" property="documentRoot" value="<%=rootDir%>" />

<jsp:useBean id="newHandler" class="ccm.pdt.PDTnewBean" scope="page" />
<jsp:setProperty name="newHandler" property="track" />
<jsp:setProperty name="newHandler" property="user" value="<%=UID%>"/>
<jsp:setProperty name="newHandler" property="problemDescriptionName" />
<%
  String uN = entry.getUserName();
  String Tr = newHandler.getTrack();
  String pdN = newHandler.getProblemDescriptionName();
  boolean status = newHandler.newProblem();
  String mess = newHandler.getMessage();
%>
<html>
<head>
  <meta http-equiv="Content-Style-Type" content="text/css">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="Keywords" content="OSC SciPortal">
  <meta http-equiv="Descriptions" content="Test - PDT">
  <title>
    TEST Problem Description Toolkit: Create a Problem
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/Test/images/bg1x.jpg">
<jsp:include page="/Test/Copyright.html" flush="true" />
<h1 class="bdr">
  TEST Problem Description Toolkit
  <br />Create A Problem
</h1>
<div class="right">
  <form name="helpform">
    <input type="button" name="submit" value="help" 
      onClick="showHelp('/SciPortal/Test/PDT/ASSISTANTPAGES/createHelp.html')">
  </form>
</div>
<p>
The problem name <% out.println("<span class=\"highlight\">" + pdN + "</span>"); %> 
is in the system somewhere, please choose another name.
<p>
Create a new problem by specifying a name for the problem (<span id="note">no 
spaces allowed</span>).
</p>
<p>
<strong>Type a name of the new problem</strong>
</p>
<form name="newProblem" method="get" action="PDThandler.jsp">
<table class="center">
<tr>
  <td colspan="2">
    <input type="text" name="problemDescriptionName" size="30">
  </td>
</tr><tr>
  <td align="left">
    <label for="User"><strong>&nbsp;User Track&nbsp;</strong></label>
    <input id="User" type="radio" name="track" value="true" checked>
    &nbsp;&nbsp;
    <label for="Advanced"><strong>&nbsp;Advanced Track&nbsp;</strong></label>
    <input id="Advanced" type="radio" name="track" value="false">
  </td><td align="left">
    &nbsp;&nbsp;&nbsp;&nbsp;
    <input type="submit" name="option" value="create">
  </td>
</tr>
</table>
</form>
</body>
</html>
