<%@ page errorPage="/Test/ErrorPage.jsp" %>
<%
  String UID = request.getRemoteUser();
  if(UID == null) UID = "ST";
  String userName = "Captain Dunsel";
  String rootDir = application.getRealPath("/");
%>
<jsp:useBean id="entry" scope="page" class="entry.EntryBean" />
<jsp:setProperty name="entry" property="user" value="<%=UID%>" />
<jsp:setProperty name="entry" property="documentRoot" value="<%=rootDir %>" />
<% String [] problemNames; %>
<jsp:useBean id="problemDescription" class="ccm.pdt.EntryBean" scope="page" />
<jsp:setProperty name="problemDescription" property="user" value="<%=UID%>" />
<jsp:setProperty name="problemDescription" property="documentRoot" value="<%=rootDir %>" />
<html>
<head>
  <meta http-equiv="Content-Style-Type" content="text/css">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="Keywords" content="OSC SciPortal">
  <meta http-equiv="Descriptions" content="TEST - PDT">
  <title>
    Test
    Problem Description Toolkit
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">
<jsp:include page="/Test/Copyright.html" flush="true" />
<h1 class="bdr">
  <div class="center">
    Test
    <br />Problem Description Toolkit
  </div>
</h1>
<div class="right">
<form class="NAV" name="helpform">
  <input type="button" name="submit" value="help" 
    onClick="showHelp('/SciPortal/Test/PDT/ASSISTANTPAGES/PDThelp.html');">
  </form>
</div>
<p>
<strong>Select an existing problem description from the list below;
or create a new problem description (by clicking the new button).</strong>
</p>
<p>
Problem Description List for
<%
  userName = entry.getUserName();
  out.print(userName + ".");
%>
</p>
<%
  problemDescription.parseOption("list");
  problemNames = problemDescription.getLp();
  int nc = problemNames.length;
%>
<table border="0" cellspacing="5">
<tr>
  <td align="right" valign="baseline">
    <%
      String aName = problemNames[0];
      if((nc == 0) || ((nc == 1) && (aName.equals("null")))){
    %>
    <p class="center">
    There are no existing problem descriptions defined.
    <br />Please use the <strong>"new"</strong> button to create one.
    </p>
    <%
      } else if ((nc > 0) && (!(aName.equals("null")))){
    %>
    <div class="left">
      <form method="get" action="/SciPortal/Test/PDT/PDTmaintenance.jsp">
        <%
          for(int i = 0; i < nc; i++) {
            out.println("<br />");
            out.print("\t\t\t<input type=\"radio\""
              + " name=\"problemDescriptionName\"");
            out.println(" value=\"" + problemNames[i]
              + "\">&nbsp;&nbsp;<span class=\"pN\">"
              + problemNames[i] + "</span>");
          }
        }
        %>
        <br />
        <input class="NAV" type="submit" name="option" value="select"></input>
      </form>
    </div>
  </td>
</tr>
</table>
<p>
<form method="get" action="/SciPortal/Test/PDT/PDTnew.html">
  <strong>Or, use the "new" button to create a new problem description.</strong>
  &nbsp;&nbsp;
  <input class="NAV" type="submit" name="option" value="new"></input>
</form>
</p>
</body>
</html>
