<%@ page errorPage="XMLUtilsError.jsp" %>
<%@ page import="java.lang.reflect.Array" %>

<%
   session.removeAttribute("xmlutils");
%>

<jsp:useBean id="xmlutil" class="util.XMLUtilsBean" scope="page"/>
<jsp:setProperty name="xmlutil" property="XMLFileName" 
  value='<%=application.getRealPath("/"+request.getParameter("fileName"))%>'/>
<jsp:setProperty name="xmlutil" property="*"/>

<html>
<head>
  <meta http-equiv="Content-Style-Type" content="text/css">
  <meta http-equiv="Content-Script-Type" content="text/javascript">
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script src="/SciPortal/js/standard.js"></script>
  <title>JSP for testing XMLUtilsBean class</title>
</head>

<body bgcolor="#f2fae4" background="/SciPortal/Test/images/bg1x.jpg">
<h2 class="bdr">
Result of processing with 
<span class="code">util.XMLUtilsBean</span> class
</h2>

The input XML file is <span class="code">
<jsp:getProperty name="xmlutil" property="XMLFileName"/>
</span>
<br /><br />
Here is all data contained in the element <span class="code">
<jsp:getProperty name="xmlutil" property="elementName"/>
</span>:
<br /><br />
<ul type="square">
<%
  String[] data0 = xmlutil.getData();
    for (int i = 0; i < Array.getLength(data0); i++) {
%>
    <li> <% out.println(data0[i]); %> </li>
<%
    }
%>
</ul>
<br /><br />
Here is all data contained in elements with the attribute-value pair
<span class="code">
<jsp:getProperty name="xmlutil" property="attName"/> = <jsp:getProperty name="xmlutil" property="attValue"/>
</span>:
<ul type="square">
<%
  String[] data2 = xmlutil.getDataByAttValPair();
    for (int i = 0; i < Array.getLength(data2); i++) {
%>
    <li> <% out.println(data2[i]); %> </li>
<%
    }
%>
</ul>

<br /><br />
Here are all attribute values contained in the element
<span class="code">
<jsp:getProperty name="xmlutil" property="elementName"/>
</span>
with attribute <span class="code">
<jsp:getProperty name="xmlutil" property="attName"/></span>:

<ul type="square">
<%
  String[] data3 = xmlutil.getAttValsByElement();
    for (int i = 0; i < Array.getLength(data3); i++) {
%>
    <li> <% out.println(data3[i]); %> </li>
<%
    }
%>
</ul>

</body>
</html>
