/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

import java.util.Vector;

import javax.naming.Context;

public class exit implements Command {
    
    String COMMAND_NAME = "exit";
    
    public void execute(Context currentContext, Vector args) 
        throws CommandException {
        System.out.println("Exiting.");
        System.exit(0);
    }
    
    public void help() {
        System.out.println("Usage: exit");
    }
}
