#include <jni.h>
#include "oreilly_jen_rmi_NativeThisOrThatServerImpl.h"
#include "nativeDoSomething.h"

#ifdef __cplusplus
extern "C" {
#endif
/*
 * Native implementation for method doSomething() on class
 * oreilly.jen.rmi.NativeThisOrThatServerImpl.
 */
JNIEXPORT jstring JNICALL Java_oreilly_jen_rmi_NativeThisOrThatServerImpl_doSomething
  (JNIEnv * env, jobject me, jstring what, jstring todo) {

  // Convert the Java strings to native strings
  const char* whatStr = (*env)->GetStringUTFChars(env, what, 0);
  const char* todoStr = (*env)->GetStringUTFChars(env, todo, 0);

  // Call the native method
  char* result = doSomethingNative(whatStr, todoStr);

  // Convert result back to Java string
  jstring res = (*env)->NewStringUTF(env, result);

  return res;
}

#ifdef __cplusplus
}
#endif
