<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
      
<xsl:template match="/">
  <html>
  <head>
    <meta http-equiv="Content-Style-Type" content="text/css" />
    <meta http-equiv="Content-Script-Type" content="text/javascript" />
    <link rel="stylesheet" href="/SciPortal/styles/standard.css" />
    <script src="/SciPortal/js/standard.js"></script>
    <meta http-equiv="Keywords" content="SciPortal" />
    <meta http-equiv="Descriptions" content="Entry" />
    <title>
      User Profile
    </title>
  </head>
  <body  bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">
  <br/>
  <br/>
  <h1 align="center">User Profile</h1>
  <p class="right">
  Return to the <span class="sP">SciPortal </span>  
  <a href="Entry.jsp">welcome page</a>.
  </p>
  <br/>
  <br/>
  <table align="center" border="3" cellpadding="4">
    <xsl:for-each select="registeredUser/User" >
    <tr>
      <td align="center" valign="center">
        <span style="color:brown; font-size:12pt; font-weight:bold;">
        UserID:<xsl:value-of select="@UID"/></span>
      </td><td align="center" valign="center" bgcolor="#66776D">
        Name:
        <xsl:value-of select="Person/title"/>
        <xsl:value-of select="Person/firstName"/>
        <xsl:value-of select="Person/middleName"/>
        <xsl:value-of select="Person/lastName"/>
      </td><td align="center" bgcolor="#3E677C">
        <xsl:value-of select="primaryArea"/>
      </td>
    </tr><tr>
      <td colspan="3" valign="center" bgcolor="#DDDDDD">
        Machines:
        <xsl:value-of select="Machine/machineID"/>
      </td>
    </tr><tr>
      <td colspan="3" valign="center" bgcolor="#DDDDDD">
        Queues:
        <xsl:value-of select="Machine/queues"/>
      </td>
    </tr><tr>
      <td colspan="3" valign="center" bgcolor="#DDDDDD">
        Codes:
        <xsl:value-of select="code/codeName"/>
      </td>
    </tr>
    </xsl:for-each>
  </table>
  </body>
  </html>
</xsl:template>
</xsl:stylesheet>
