package WebFlow.XML;
import WebFlow.*;
import WebFlow.submitJob.*;
import WebFlow.xml.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import org.w3c.dom.*;
import com.ibm.xml.parser.ExternalID;
import com.ibm.xml.parser.Parser;
import com.ibm.xml.parser.TXDocument;
import com.ibm.xml.parser.DTD;
import java.io.*;
import java.util.*;
import java.net.*;

public class CommandLineFinding extends java.lang.Object{

String msg_;
org.omg.CORBA.Object peer;
private static Parser parser;
private static Document doc;
public String[] piplist;
public String[] poplist;
String[] ipfiles;
String[] opfiles;
String str;

public static String RSL;
public static String InstallRSL;
public static submitJob submit;
public static XmlServer xmlserver;

private static WebFlowContext ws;
private static org.omg.CORBA.Object p1,p2;
  
public static void main(String args[])
{
        String Fname= args[1];
        String FADname="";
        String Command=""; 
        DTD dtd;
        System.out.println("The name is: "+Fname);
        if (connected(args))
            {
              if(xmlserver.instantiateParser(Fname))// read ATD.xml file
              {
	        FADname=GetADFileName();  // to find out the AD.xml file name
                System.out.println("This XML file is: "+ FADname);
	        if(xmlserver.instantiateParser(FADname)) //Parse the AD.xml File
                {
                 System.out.println("This args is: "+args[2]+args[3]); 
	         Command= getCommandLine(args[2],args[3]); //find a command Line
                 System.out.println("This Command Line is: "+ Command);
                }
              }
              else 
              System.out.println("This XML file is not exited!");

	      //        submit.submitLocally("xterm -d jojo:0");
             System.out.println("Entering submit command ..... "); 
             submit.submitLocally(Command);  //submit Command line
             System.out.println("Finish the  submit command "); 
	     ws.removeModule(p1);
             ws.removeModule(p2);
            }
         
         else{
             System.out.println("connection failed"); 
             }
	


};


  /* public static  boolean instantiateParser(String FileName) {
        boolean status = false;
        try {
            File infile = new File(FileName);
            if(infile.exists()) {
              FileInputStream is = new FileInputStream(FileName);
              parser = new Parser(FileName);
              doc = parser.readStream(is);
              if(parser.getNumberOfErrors() > 0) {
               System.out.println("Sorry, the xml document has errors");
//System.exit(1);
              }
              else {
               status = true;
              }
            }
            else {
               System.out.println("Sorry, file "+FileName+" does not exist");
            }
        } catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
        }
       return status;
    };
    */
 public static Vector getAllTags(Node node, String tag) {
        Vector result=new Vector();
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    result.addElement(ch);
                 }
              }
          }
      return result;
};


 public static String GetADFileName(){
        System.out.println("function entered.......");
        Vector vlist = new Vector();
        Vector pilist = new Vector();
        String FileName="";
        try{
        Node root=doc.getDocumentElement();
        Vector rtags =getAllTags(root, "application");
	int rn = rtags.size();
        for (int i=0; i<rn; i++){
                Node ch = (Node)rtags.elementAt(i);
				FileName =((Element)ch).getAttribute("descriptor");
				}		 //find the file's name in descriptor.
	}
        catch (Exception e){
                System.out.println(e);
                e.printStackTrace();
        }	
        return FileName;  

};

 public static String getCommandLine(String Applicationname,String hostname) {
      String rsl="not ready yet";
      boolean status = false;
      String command="";
      String path=""; 
      String exec="";
   try {
       Node root=doc.getDocumentElement();
       Node rootC1 = findTagWithAttribute(root,"application","id",Applicationname); 
       if(rootC1!= null)
        {    
             Node ch = findTagWithAttribute(rootC1,"target","id",hostname);
             if(ch != null) 
             {
              if(getAttributeValue(ch,"status","installed").equals("Yes"))
                {
                status=true;
                }
              if(status) {
                  // find node <installed>
                  Node ch1 = findFirstTag(ch,"installed");
                  // executable or a script to be generated?
                  Node Snode = findFirstTag(ch1,"script");
                  if(Snode == null) {
                     // retrieve CmdLine
                     Snode = findFirstTag(ch1,"CmdLine");
                     if (Snode == null) {
                       System.out.println("Oops, no CmdLine node!");
                     }
                     else {
                       Node ch2 = findFirstTag(Snode,"Command");
                       if (ch2 == null) {
                         System.out.println("Oops, no Command node!");
                         }
                       else{
                         path = ((Element)ch2).getAttribute("path");
                         exec = ((Element)ch2).getAttribute("exec"); 
                         command=exec+" "+path;  
 System.out.println("Finding the command is......"+command);
                           }
                     }
                  }
                   else {
                    // there is a script to be generated
                    
                   Node Mnode = findFirstTag(Snode,"module");
                     if(Mnode != null) {
                     rsl  = "script:";
                     rsl += "name="+((Element)Mnode).getAttribute("name");
                     rsl += " idl="+((Element)Mnode).getAttribute("idl");
                     rsl += "class="+((Element)Mnode).getAttribute("class");
		     }
                     else {
                     System.out.println("something fishy... no module tag");
                    }
		   }//else for Snode
              }
              else {
               System.out.println("Sorry, this application is not installed "+" on "+hostname);
              }//else for status
             }//end of if?
	   }// end of application id check
	 else{
             System.out.println("Sorry, Here have no the application name  "+Applicationname);
          }
	}//end of try.
   catch (Exception e) {
              System.out.println(e);
              e.printStackTrace();
        }
return command;
    };
 
 private static Node findTagWithAttribute(Node node, String tag,
                                      String attr, String value) { 
        Node result=null;
        for(Node ch = node.getFirstChild(); ch!=null;ch = ch.getNextSibling())          {            
           if(ch instanceof Element) {
                  if(ch.getNodeName().equals(tag)) {
                    if(((Element)ch).getAttribute(attr).equals(value)){
                           result=ch;
                           break;
                        }
                 }
              }
          }
return result;
    }; 

 private static String getAttributeValue(Node node, String tag, String name) {
        String value="";
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                   if(ch.getNodeName().equals(tag)) {
                    value=((Element)ch).getAttribute(name);
                    break;
                 }
              }
          }
      return value;
    };


 private static Node findFirstTag(Node node, String tag) {
        Node result=null;
          for(Node ch = node.getFirstChild(); ch!=null;
                                             ch = ch.getNextSibling()) {
              if(ch instanceof Element) {
                 if(ch.getNodeName().equals(tag)) {
                    result=ch;
                    break;
}
              }
          }
      return result;
    };


 public static boolean connected(String args[]){
      try
      {
       //  Create ORB
        Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);
         ORB orb = ORB.init(args, props);
         String masterURL = args[0] ; 
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 
         ref = getIORFromURL(masterURL);
         System.out.println("REF: "+ref); 
         obj = orb.string_to_object(ref); 
         if(obj == null)
              throw new RuntimeException(); 
         ws =  WebFlowContextHelper.narrow(obj); 
         System.out.println("Clinet: got master "+ws);
         if(ws == null)
               throw new RuntimeException();
         System.out.println("attach submitJob------------------------");                p1 = ws.addNewModule("submitJob");
         submit = submitJobHelper.narrow(p1); 
         p2 = ws.addNewModule("XmlServer");
	 xmlserver = XmlServerHelper.narrow(p2);
       	 submit.test();
	 xmlserver.test();
         }
       catch(COMM_FAILURE ex)
	   {
          System.out.println("Command_Error: "+ex);
          System.err.println(ex.getMessage());
          ex.printStackTrace(); 
        		   System.exit(1); 
	   } 
    return true;
 };

static public String getIORFromURL(String url) {
    System.out.println("Slave WebFlow is getting IOR from url:"+url);
    String masterServerIOR =""; 
    String thisLine = null ;
   // Open the URL for reading
    try{
         URL u = new URL(url);       
        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());
         while((thisLine = theHTML.readLine()) != null){ 
         masterServerIOR += thisLine ;      } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
     }
    return masterServerIOR ; 
  }



};

	
