package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.Base64.*;
//import WebFlow.Charon.*;
import org.omg.CORBA.*;
//import WebFlow.QS.*;
import WebFlow.xml.*;
import WebFlow.hashtable.*;
import WebFlow.FB.*;
import WebFlow.ContextManager.*;
import WebFlow.RemoteFile.*;
import WebFlow.submitJob.*;
import java.lang.reflect.*;
//import WebFlow.PSEscript;
import java.util.*;
                               
public class GatewayPortalJKL extends HttpServlet {
  private ORB orb;
  private org.omg.CORBA.Object m1,m2,m3,m4,m5,m6,m7;
    //m1-ContextData; m2-SaveContext; m3-ContextManager;
    //m4-XmlServer; m5-RemoteFile; m6-submitJob; m7-FBServer;
  ContextData cd;
  SaveContext sc;
  ContextManager cm;
  XmlServer aad;
  RemoteFile rf;
  submitJob sj;
  FBServer fb;
  private WebFlowContext ws = null;
  PrintWriter out;
  private String ior;
  private WebFlowContext masterServer, userContext;
  private boolean notReady, masterOn, userContextOn;
  private int icount;
  private String masterRef, masterID;
  private String userName;

    //  private final String classpath = "/usr/local/apache_t3.1/htdocs/SciPortal/WEB-INF/classes:/home/haupt/JORB/JOB-3.1.2/lib/OB.jar";
    private final String classpath = "/usr/local/apache_t3.1/htdocs/SciPortal/WEB-INF/classes:/usr/local/orbacus-3.3.1/JOB/OB.jar";


  private String masterIOR;
  private String userDir;
  private String entryDir;

  private final String xterm = "xterm";


  protected void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {
        doPost(req, res);
  }


  protected void doPost(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {

    System.out.println("start servlet");
    out = res.getWriter();
    res.setContentType("text/html");
    //out.println("<head>");
    //out.println("<title>start user context</title>"); 

    //out.println("</head>");
    //out.println("<body bgcolor=\"white\">");
    //out.println("<center>");
    //out.println("<h3> GatewayPortal</h3>");
    //out.println("</center>");
    //out.println("<p>");

//jkl  private final String masterIOR="/usr/local/apache_t3.1/htdocs/SciPortal/IOR/master.txt";
    masterIOR = getServletContext().getRealPath("/IOR/master.txt");
    System.out.println("IOR master.txt is at: "+masterIOR);

//jkl private final String userDir = "/usr/local/apache_t3.1/htdocs/SciPortal/WEB-INF/Descriptors/users";

    userDir = getServletContext().getRealPath("/WEB-INF/Descriptors/users");
    System.out.println("users top dir: "+userDir);

//jkl  private final String entryDir = "/usr/local/apache_t3.1/htdocs/SciPortal/Entry";
    entryDir = getServletContext().getRealPath("/Entry");
    System.out.println("/Entry: "+entryDir);

    String[] args = new String[1];
    if((args[0]=req.getParameter("config")) == null) {
	args[0]=getServletContext().getRealPath(
                "/WEB-INF/Distribution/BeanContext_2.2.3/master.conf");
   }
    System.out.println("Config file: "+args[0]);

    // The Xwindow display specification where debug Xterm is shown
    // e.g., krakow.osc.edu:0
    String debugDisplay; 
    if((debugDisplay = req.getParameter("debugDisplay")) != null) {
   System.err.println("debugDisplay parameter is: "+debugDisplay);
	int l = debugDisplay.length();
	int k = debugDisplay.indexOf(':');
        if(k<0) debugDisplay = "nodisplay";
	if((k < l-3) || (k > l - 1)) { 
	    System.err.println("debugDisplay set to: "+debugDisplay);
	}
    }
    else { // take default
	debugDisplay = "nodisplay";
    }


    /* first check whether the master server is already running */

    masterOn=false;
    masterRef = ReadIORFromFile(masterIOR);
    if(masterRef.length()>10) {
        try {
              orb = ServerServlet.orb;
              if(getMaster(masterRef)) {
                 if(pingServer(masterServer)) {
                   masterOn=true;
                   masterID = masterServer.getObjectID();  
		 }
	      }
	} catch (java.lang.NullPointerException npe) {} 
    }

    if(!masterOn) {
	//out.println("Sorry, the Gateway Server is down.");
    }

    else {
	//out.println("The Gateway Server is on<br>");

      /* learn the user id */
   
      String auth = req.getHeader("authorization");
      StringTokenizer st = new StringTokenizer(auth);
      String copa = st.nextToken();
      copa = st.nextToken();
      Base64Decoder decoder = new Base64Decoder(copa);
      try {
      String decoded = decoder.processString();
      StringTokenizer st1 = new StringTokenizer(decoded,":");
      userName = st1.nextToken();
      //      out.println("<h3> Hello, my dear user "+userName+"</h3>");
      } catch (Exception e) {
        System.err.println("cannot decode "+copa);
        System.err.println(e);
      } 

      /* check whether the user context is already running */
      
      userContextOn = false;
      try {  
        org.omg.CORBA.Object ouc = 
           masterServer.getContext(masterID+"/"+userName);
        userContext = WebFlowContextHelper.narrow(ouc);
	if(pingServer(userContext)) {
	    //out.println("user context in on<br>");
          userContextOn = true;
          CopyWebPage("Portal.html");    
	}
        else {
	    //out.println("user context is off<br>");
          userContextOn = false;
	}  
      } catch (Exception e) {
	  //out.println("user context is off<br>");
         userContextOn = false;
      }

      System.err.println("userContextOn? "+userContextOn);
      //out.println("userContextOn? "+userContextOn+"<br>");
      /* start the user context, if not already running */ 
         
      if(!userContextOn) {
        String configFile = userDir+"/"+userName+"/"+userName+".conf";
        System.err.println("Config File "+configFile);


//jkl      String command = "java -cp "+classpath+ " WebFlow.Server "+configFile;

      String command = "runjava.sh WebFlow.Server " + configFile;
      System.err.println("Command to start WebFlow.Server "+command);
        File cff = new File(configFile);

        if(!cff.exists()) {
	    /* boomer!  we have to create a new configuration file */
         createNewConfFile(userName);  
	}
	else {
	    // create it anyway; when Jan reinstalls WebFlow it must be
            // regenerated; it took me 3 hours to find that! Tom
         createNewConfFile(userName);  
	}

        if(!debugDisplay.equals("nodisplay")) {
            command = xterm+" -display "+debugDisplay+ " -e "+command;

	} 
        System.err.println("The command for the slave is: "+ command);
        Process p = Runtime.getRuntime().exec(command);

          /* wait till the server is on */
          notReady = true; 
          icount = 0;

    while(notReady) {
      icount++;
      waitFor(2500);
      //out.println("step "+icount+"<br>");
      try {
        org.omg.CORBA.Object ouc = 
           masterServer.getContext(masterID+"/"+userName);
        userContext = WebFlowContextHelper.narrow(ouc);
	if(pingServer(userContext)) {
	    //out.println("user context in on<br>");
          notReady = false;
	}
        else {
	    // out.println("user context is off<br>");
          notReady = true;
	}  
      } catch (Exception e) {
	  //out.println("user context is off<br>");
          notReady = true;          
      }

    }

        /* attach modules */
    //out.println("now attach modules");
    
           m1 = userContext.addNewModule("ContextData");
      	   cd  = ContextDataHelper.narrow(m1);
           cd.test();

           System.out.println("attach SaveContext"); 

           m2 = userContext.addNewModule("SaveContext");
      	   sc  = SaveContextHelper.narrow(m2);
           sc.test();

           System.out.println("attach ContextManager"); 

           m3 = userContext.addNewModule("ContextManager");
      	   cm  = ContextManagerHelper.narrow(m3);
           cm.test();

           System.out.println("attach aad"); 

	   /*
           m4 = userContext.addNewModule("aad");
      	   aad  = XmlServerHelper.narrow(m4);
           aad.test();
	   */

           System.out.println("attach RemoteFile"); 

           m5 = userContext.addNewModule("RemoteFile");
      	   rf  = RemoteFileHelper.narrow(m5);
           rf.test();

           System.out.println("attach submitJob"); 

           m6 = userContext.addNewModule("submit");
      	   sj  = submitJobHelper.narrow(m6);
           sj.test();

           System.out.println("attach FileBrowser"); 

           m7 = userContext.addNewModule("FileBrowser");
      	   fb  = FBServerHelper.narrow(m7);
           fb.test();

           System.out.println("initialize ContextManager");             

           cm.init(userContext,m2,m5);

           System.out.println("userName="+userName);
           System.err.println(cm.getObjectID());

           // register modules and user context (for perfomance)
           ServerServlet.setUserContext(userName,userContext);
           ServerServlet.setContextManager(userName,cm);                     
           ServerServlet.setFileBrowser(userName,fb);
           ServerServlet.setRemoteFile(userName,rf);
           ServerServlet.setSubmitJob(userName,sj);
           //ServerServlet.setAAD(userName,aad);


           if(!cm.setUserContextData(userContext,userDir,userName)) {
	       //Restore ContextData
	       //read contents of the userContextData
              
               String rootDir = userDir + "/" + userName;
	       sc.readContextData(userContext,rootDir);
               
	       System.out.println("now restore contexts");
               restoreChildren(userContext);
	   }
           CopyWebPage("Portal.html");    
	}  
 
    System.err.println("about to flush 111");
    System.out.println("about to flush 222");
    fb.test();
    out.flush();
    out.close();
    }
  }

  void error(String msg)
  {
    out.println(msg);
  }

  void status(String msg)
  {
    //out.println(msg);
  }
                              
  public String getServletInfo()
  {
  return "By T. Haupt";
  }

    public synchronized void waitFor(long howLong) {
	try {
              wait(howLong);
	} catch (Exception e) {System.err.println(e);}
    }

  public String ReadIORFromFile(String masterIOR)   {
      //open a file
      FileInputStream theFile;
      BufferedReader fileReader;
      String sObjRef;

      try {
           theFile=new FileInputStream(masterIOR);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
           return "";
      }

      //read a reference string
      try {
        sObjRef=fileReader.readLine();
        System.err.println("Got the reference: "+sObjRef);
      }
      catch (IOException e) {
        return "";
      }
      
      try {
        theFile.close();
        fileReader.close();
      }
      catch (IOException e) {}

      //return the reference string
      return sObjRef;
  }

    public boolean getMaster(String MasterRef){
       org.omg.CORBA.Object ws = orb.string_to_object(MasterRef);
       if(ws==null) return false;
       masterServer = WebFlowContextHelper.narrow(ws);
       if(masterServer==null) return false;
       else return true;
    }

    public boolean pingServer(WebFlowContext ws) {
	boolean non_exist = true;
	try{
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

        return !non_exist;
    }       

    public void createNewConfFile(String user) {

	System.err.println("createNewConfFile");
       File uDir = new File(userDir+"/"+user);
       if(!uDir.exists()) uDir.mkdir();
       try {
         FileReader fr = new FileReader(userDir+"/template.conf");
         BufferedReader in = new BufferedReader(fr);
         System.err.println("write conf to "+userDir+"/"+user+"/"+user+".conf");
         FileWriter fw = new FileWriter(userDir+"/"+user+"/"+user+".conf");
         fw.write("ServerName="+user+"\n");
         while(true) {  
          String nextLine = in.readLine();
          if(nextLine == null) break;
          fw.write(nextLine+"\n");
	 } 
         in.close();
         fw.flush();
         fw.close();  
       } catch (Exception e) { System.out.println(e);}         
    } 

    public void CopyWebPage(String fileName) {

       try {
         FileReader fr = new FileReader(entryDir + "/" + fileName);
         BufferedReader in = new BufferedReader(fr);
         while(true) {  
          String nextLine = in.readLine();
          if(nextLine == null) break;
          out.println(nextLine);
	 } 
         in.close();
       } catch (Exception e) { System.out.println(e);}         
    } 

    public void restoreChildren(WebFlowContext context) {
	System.out.println("starting restoration ...");
        if(cm==null) System.out.println("cm is null"); 
        if(context==null) System.out.println("context is null"); 
     String children=cm.getContextData(context,"Children");
     System.err.println("children: "+children); 
     String pDir=cm.getContextData(context,"Directory");
     System.err.println("directory: "+pDir); 
     if(children.equals("null")) { 
         // no more children: job done
         System.out.println("no more children: job done");
         return;
     }
     else {
         //Children are in format:  name1+name2+name3
         StringTokenizer st = new StringTokenizer(children,"+");
         if(st.hasMoreTokens()) {
             System.out.println("has more tokens");
	     String Child = st.nextToken();
             System.err.println("restore context "+Child);
             // create an empty context and put ContextData module to it
             WebFlowContext cc = restoreContext(context,Child);
             // a context name may have a suffix: .PC, .SC, or .AC. strip it
             String cDir = Child;
             int idx = Child.lastIndexOf(".");
             if(idx>-1) {
		 cDir = Child.substring(0,idx); 
             }  
             cDir = pDir+File.separator + cDir;
             System.out.println("cDir="+cDir);  
             sc.readContextData(cc,cDir);
             restoreChildren(cc);
	 }
     }
    }

  public WebFlowContext restoreContext(WebFlowContext p, String name){
    try {
    WebFlowContext c = WebFlowContextHelper.narrow(p.addNewContext(name));
    if(c==null) System.out.println("c is null");
    ContextData cdm = ContextDataHelper.narrow(c.addNewModule("ContextData"));
    if(cdm==null) System.out.println("--->cd is null");
    return c;
    } catch (Exception e) {
       System.out.println(e +"while createGatewayContext");
       return null;
    }  
  }


}




