package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.Base64.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import WebFlow.RemoteFile.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;

public class RemoteFileServlet extends HttpServlet{

	ServletOutputStream out;
	ContextManager cm;
	private String userName; 
	private String option;
	private String problemName;
        private RemoteFile rf;

	public void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {

        String auth = req.getHeader("authorization");
        StringTokenizer st = new StringTokenizer(auth);
        String copa = st.nextToken();
        copa = st.nextToken();
        Base64Decoder decoder = new Base64Decoder(copa);
        try {
          String decoded = decoder.processString();
          StringTokenizer st1 = new StringTokenizer(decoded,":");
          userName = st1.nextToken();
        } catch (Exception e) {
          System.err.println("cannot decode "+copa);
          System.err.println(e);
        } 

  out = res.getOutputStream();
  res.setContentType("text/html");

  printHead("RemoteFileServlet");

 
  rf = ServerServlet.getRemoteFile(userName);
  if(rf==null) {
     System.err.println("RF object is null");
     prnt("file browser is not available<br>");
  }
  
  else { 

     System.err.println("RF object found");
     prnt("file browser attached<br>");

    String option = req.getParameter("method");

    prnt(option);

    if(option==null) {
	prnt("no method given: no action!");
    }

    else { 

 
    if(option.equals("download")) {
	String template = req.getParameter("template");
        String htmlFile = req.getParameter("html");
        String message = req.getParameter("message");
        boolean t = rf.HtmlTemplate(template,htmlFile,message); 
        if(t) prnt("\nResponse:true"); else prnt("\nResponse:false"); 
    }

    if(option.equals("upload")) {
	String template = req.getParameter("template");
        String htmlFile = req.getParameter("html");
        String message = req.getParameter("message");
        boolean t = rf.HtmlTemplate(template,htmlFile,message); 
        if(t) prnt("\nResponse:true"); else prnt("\nResponse:false"); 
    }

      if(option.equals("mkdir")) {
         String filename = req.getParameter("filename");
         boolean t = rf.mkdir(filename);
         if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
      }

      if(option.equals("rmdir")) {
         String filename = req.getParameter("filename");
         boolean t = rf.rmdir(filename);
         if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
      }

      if(option.equals("delete")) {
         String filename = req.getParameter("filename");
         boolean t = rf.delete(filename);
         if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
      }

      if(option.equals("rename")) {
         String filename = req.getParameter("filename");
         String newname = req.getParameter("NewName");
         boolean t = rf.rename(filename, newname);
         if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
      }

      if(option.equals("move")) {
         String filename = req.getParameter("filename");
         String newname = req.getParameter("NewName");
         boolean t = rf.rename(filename, newname);
         if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
      }

      if(option.equals("copy")) {
         String filename = req.getParameter("filename");
         String newname = req.getParameter("NewName");
         boolean t = rf.copy(filename, newname);
         if(t) prnt("\nResponse:true"); else prnt("\nResponse:false");
      }
     }
  }

  out.println("</BODY>");    
  out.println("</HTML>");

  out.flush();
  out.close();

  }

  public void printHead(String title) {
    prnt("<html>");
    prnt("<TITLE>");
    prnt(title);
    prnt("\t</TITLE>");
    prnt("</HEAD>");
    prnt("<BODY STYLE=\"color:black;\" BGCOLOR=\"#f2fae4\" BACKGROUND=\"/SciPortal/ccmImages/bg1x.jpg\">");
    prnt("<H1 ALIGN=\"center\">"+title+"</H1>");
  }

 
  public void prnt(String msg){
    try{
      out.println(msg);
    } catch (Exception e){System.out.println(e);}
  }

    public String formatDate(String d){
      Date dateD=null;
      long dateL;
      SimpleDateFormat formatter = new SimpleDateFormat("s",Locale.getDefault());
      try {
      dateL = (new Long(d)).longValue();
      dateD = new Date(dateL);
      formatter.applyPattern("yyyy-MMM-d HH:mm:ss");
      } catch (Exception e) {System.out.println(e);}
      String dateS = formatter.format(dateD);
      return dateS;  
    }

  public String getServletInfo(){
    return "By T. Haupt and K. Flurchick";
  }

}



