import java.util.Vector;

import org.xml.sax.XMLReader;
import org.xml.sax.Attributes;
import org.xml.sax.InputSource;
import org.xml.sax.helpers.DefaultHandler;
import org.apache.xerces.parsers.SAXParser;
import org.xml.sax.ErrorHandler;
import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;

public class Test extends DefaultHandler
{
  public static String elementName = "";
  public static Vector vec = null;
  public static String templateName = "problemName";
  public Test() {
    super();
  }

  public static void main(String[] args) throws Exception
  {
 
    String[] problemNames;
    problemNames = new String[] { "0", "1" };
    vec = new Vector();
    String userName="abe";
    String usersDir="/usr/local/apache_t3.1/htdocs/SciPortal/WEB-INF/Descriptors/users";
    XMLReader xr = new SAXParser();
    Test handler = new Test();
    xr.setContentHandler(handler);
    xr.setErrorHandler(handler);
    xr.setFeature("http://xml.org/sax/features/validation", true);
    xr.setFeature("http://xml.org/sax/features/namespaces", false);
    xr.setFeature("http://xml.org/sax/features/namespace-prefixes", false);
    String XMLfile = usersDir + "/" + userName + "/" + userName + 
                     ".xml";
    xr.parse(new InputSource(XMLfile));
    for (int i = 0; i < vec.size(); i++)
    {
      problemNames[i] = (String)vec.get(i);
      System.out.println(problemNames[i].trim());
    }
  }

    public void startElement(String uri, String name,
    String qName, Attributes atts)
  {
    elementName = qName;
  }

  public void characters(char ch[], int start, int length)
  {
    if (elementName.equals(templateName))
    {
      String pName = new String(ch, start, length);
      vec.add(pName);
    }
  }

  public void warning(SAXParseException ex)
  {
    System.err.println("[Warning] "+
                       getLocationString(ex)+": "+
                       ex.getMessage());
  }

  /** Error. */
  public void error(SAXParseException ex)
  {
    System.err.println("[Error] "+
                       getLocationString(ex)+": "+
                       ex.getMessage());
  }

  /** Fatal error. */
  public void fatalError(SAXParseException ex)
    throws SAXException
  {
    System.err.println("[Fatal Error] "+
                       getLocationString(ex)+": "+
                       ex.getMessage());
    throw ex;
  }
  /** Returns a string of the location. */
  private String getLocationString(SAXParseException ex)
  {
    StringBuffer str = new StringBuffer();

    String systemId = ex.getSystemId();
    if (systemId != null)
    {
      int index = systemId.lastIndexOf('/');
      if (index != -1)
        systemId = systemId.substring(index + 1);
      str.append(systemId);
    }
    str.append(':');
    str.append(ex.getLineNumber());
    str.append(':');
    str.append(ex.getColumnNumber());

    return str.toString();
  } // getLocationString(SAXParseException):String
}
