package Toolkits.ccmCt.util;

// provides the method to retrieve full physical path to user top directory 

import javax.servlet.ServletContext;
import javax.servlet.http.*;
import java.io.File;


public class UserTopDir {

    public static String topDir (HttpServletRequest req,
				 ServletContext sContext) {
	String user = req.getRemoteUser();
	String contextDir = sContext.getRealPath("/");
	String path = contextDir + File.separator + "WEB-INF" 
	    + File.separator + "Descriptors" + File.separator
	    + "users" + File.separator + user + File.separator;
	return path;
    }
}




