/**
 * Method: parseColon
 * @param	String Line
 * @param	int endLoop
 * @return	int ij[]
 * @throws	None
 * <p>
 * Search for a number of colons and return the specified occurence.
 * The int endLoop is the number of colons to find.
 * The int i is returned as the beginning index of the substring.
 * The int j is the index of the last colon (also the ending index 
 * of the substring).
 * </p>
 */
	public static void parseColon(String Line, int endLoop){
		int kv; // Dummy loop counter
		int i = 0, j = 0;

		i = 0;
		j = -2;
		for(kv = 0; kv <= endLoop; kv++){
			i = j + 2;
			j = Line.indexOf("::", i);
		}
		ij[0] = i;
		ij[1] = j;
        }