package util;

public class SmartStringArray
{

  int sp = 0;
  private String[] array;
  private int growthSize;

  public SmartStringArray()
  {
    this(64);
  }

  public SmartStringArray(int initialSize)
  {
    this(initialSize, (int)(initialSize / 4));
  }

  public SmartStringArray(int initialSize, int growthSize)
  {
    this.growthSize = growthSize;
    array = new String[initialSize]; 
  }

  public void add(String s)
  {
    if(sp >= array.length) // time to grow
    {
      String[] tmpArray = new String[array.length + growthSize];
      System.arraycopy(array, 0, tmpArray, 0, array.length);
      array = tmpArray;
    }
    array[sp] = s;
    sp += 1;
  }

  public String[] toArray()
  {
    String[] trimmedArray = new String[sp];
    System.arraycopy(array, 0, trimmedArray, 0, trimmedArray.length);
    return trimmedArray;
  }
  
} 
