<?xml version="1.0"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="1.0">
 
<xsl:template match="/">
  <xsl:for-each select="problemDescription">
  <html>
  <head>
    <meta content="text/css" http-equiv="Content-Style-Type"/>
    <meta content="text/javascript" http-equiv="Content-Script-Type"/>
    <link href="/SciPortal/styles/standard.css" rel="stylesheet"/>
    <script src="/SciPortal/js/standard.js"></script>
    <meta content="SciPortal" http-equiv="Keywords"/>
    <meta content="Entry" http-equiv="Descriptions"/>
    <title>
      Problem Description for 
      <xsl:value-of select="problemDescriptionName" />
    </title>
  </head>
  <body bgcolor="#f2fae4" background="/SciPortal/images/bg1x.jpg">
  <br/><br/>
  <h2 class="bdr1">
    Problem Description for 
    <span class="highlight">
    <xsl:value-of select="problemDescriptionName"/></span>
  </h2>
  <br/><br/>
  <p class="right">
  Return to the <span class="sP">Problem Description Toolkit  </span>
  <a href="PDTentry.jsp">entry page</a>.
  </p>
  <br/><br/>
  <table border="0" celpadding="5">
  <tr>
    <td colspan="2" align="center">
      <br /><br /><br />
      <p>
      The Problem Description name is:
      <span style="color:brown; font-size:12pt; font-weight:bold;">
      <xsl:value-of select="problemDescriptionName"/></span>
      </p>
    </td>
  </tr><tr>
    <td class="left">
      <p>
      SciPortal track is <span class="highlight">
      <xsl:value-of select="usertrack"/></span>
      </p>
    </td>
  </tr>
  </table>
  </body>
  </html>
  </xsl:for-each>
</xsl:template>
</xsl:stylesheet>
