/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

package entity.beanManaged;

import javax.ejb.*;
import java.rmi.Remote;
import java.rmi.RemoteException;

/**
 * Remote interface for a Profile enterprise bean.
 */
public interface Profile extends Remote, EJBObject {
  public String getName() throws RemoteException;
  public String getEntry(String key) throws RemoteException;
  public void setEntry(String key, String value) throws RemoteException;
}
