/*
 * This example is from the book "Java Enterprise in a Nutshell".
 * Copyright (c) 1999 by O'Reilly & Associates.  
 * You may distribute this source code for non-commercial purposes only.
 * You may study, modify, and use this example for any purpose, as long as
 * this notice is retained.  Note that this example is provided "as is",
 * WITHOUT WARRANTY of any kind either expressed or implied.
 */

import java.rmi.Naming;

public class AccountManagerReg {
  public static void main(String argv[]) {
    try {
      AccountManager mgr = new AccountManagerImpl();
      Account one = new AccountImpl("Fred");
      mgr.newAccount(one);
      Account two = new AccountImpl("Wilma");
      mgr.newAccount(two);
      Naming.rebind("acctManager", mgr);
    }
    catch (Exception e) {}
  }
}
