package WebFlow.Charon;
import java.net.*;
import java.io.*;

public class CharonClient {

static URL target;

   public static void main(String[] args) {
     String IorUrl="http://osprey4.npac.syr.edu:8001/IOR/charon.txt"; 
     if(args.length < 1) {
       System.out.println(" ");
       System.out.println("Usage: java WebFlow.Charon.Client url");
       System.out.println("where url is base url of the target server");
       System.exit(0);
     }
     else {
       String UrlString = args[0];
       try {
            target = new URL(UrlString);
       } catch (MalformedURLException e) {
         System.out.println(" ");
         System.out.println("The base url of the target server is incorrect");
         System.out.println(UrlString);
         if(!UrlString.startsWith("http")) {
            System.out.println("must starts with http");
	 }
         System.exit(0);
       }
       try {
          InputStream is = target.openStream();
          is.close();
       } catch (IOException e) {
         System.out.println(" ");
         System.out.println("The target server seems to be down");
         System.out.println(UrlString);
         System.exit(0);
       }
       new MyCharon(IorUrl, UrlString); 
     }
   }
}

