#!/usr/local/bin/perl

#
# Program is run as:
#
#	ParseCCM.pl <code> <analysis> <file>
#

usage() if( ($#ARGV > 4) || ($#ARGV < 3) );

$code = $ARGV[0]; 
$display = $ARGV[1]; 
$dataFile = $ARGV[2]; 
$htmlFile = $ARGV[3]; 
$outFile = $ARGV[4]; 

$code = lc($code);
$analysis = uc($display);

$parser = "$analysis" . "$code" . ".pl";

@command = ($parser, $dataFile, $htmlFile, $outFile);

system @command;

sub usage() {
  die <<"EOU"

  usage: $0 <code_name> <analysis_type> <output_filename>

  For example, <code_name> can be "gaussian" or "gamess" and
  <analysis_type> can be "SCF", "OE", or "MC"
EOU
}

