<%@ page errorPage="/CCM/ErrorPage.jsp" language="java"
    session="true" import="java.io.*,ccm.ct.util.*" 
 %>
<jsp:useBean id="storeInfo" class="ccm.ct.beans.StoreProjectInfoBean" scope="session" />
<html>
<head>
  <link rel="stylesheet" type="text/css" href="/SciPortal/styles/standard.css">
  <script type="text/javascript" src="/SciPortal/js/standard.js"> </script>
  <meta http-equiv="Keywords" content="SciPortal">
  <meta http-equiv="Descriptions" content="CCM - CT">
  <title>
    CCM PSE Code Toolkit Form 1
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg"
  onLoad="loadNavigator('/SciPortal/CCM/CT/CTnavigator.jsp');">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<hr size="10" />
<br /><br />
<h1 class="center">Welcome to the Code Toolkit (CT)</h1>
<%  
  String userName = storeInfo.getUserName();
  String projectName = storeInfo.getProjectDescriptionName();
  String track = storeInfo.getTrack(); 
  String userPath = application.getRealPath("/") 
    + "WEB-INF" + File.separator + "Descriptors" + File.separator 
    + "users" + File.separator + userName;  
  projectName = projectName.replace(' ', '_');
  projectName = projectName.replace(':', '_');
   
  ccm.ct.util.CTUtilities ccmut = new ccm.ct.util.CTUtilities();

  String projectPath = userPath + File.separator + projectName;
  System.err.println("In CTentry.jsp, projectPath=" + projectPath); 
  System.err.println("In CTentry.jsp, userPath=" + userPath); 

  storeInfo.setProjectPath(projectPath);
  storeInfo.setUserPath(userPath);

  System.out.println("projectPath = " + projectPath);
  String commandLog;

  File projectDir = new File(projectPath);

  if(! projectDir.exists()) {
    projectDir.mkdir();
  }
  // Change directory permissions to webrun2.webrun2 and 775
  String webUser = "webrun2";
  String webGroup = "webrun2";
  commandLog = ccmut.execCommandLocally("chown -R " + webUser 
    + " " + projectPath);
  commandLog = commandLog + ccmut.execCommandLocally("chgrp -R " 
    + webGroup + " " + projectPath);
  commandLog = commandLog + ccmut.execCommandLocally("chmod -R " 
    + "ug+w " + projectPath);

  System.err.println("CTentry.jsp: "+ commandLog);
%>
<div class="right">
<form name="Helper">
  <input type="button" name="submit" value="help"
    onclick="showHelp('/SciPortal/CCM/CT/ASSISTANTPAGES/CThelp.html');">
  </input>
</form>
</div>
<hr size="10" />
<p>
The <strong>C</strong>ode <strong>T</strong>oolkit (CT) provides the user 
with a selection of codes available to implement the solution for the 
specified problem.  The code choices are displayed in the navigator above.
<span class="NOTE">For this tutorial, there is no default code.</span>
</p>
<ul type="square">
  <li>Default - This is the recommended default choice for this type of 
      problem.
      <br /><br />
  <li>List of Code Names: if you want to select a different code, click 
      on the preferred code.
</ul>
<hr size="10" />
</body>    
</html>
