<%@ page  language="java"
    session="true" import="java.io.*,java.util.*" 
 %>
<jsp:useBean id="storeInfo" class="ccm.ct.beans.StoreProjectInfoBean"
 scope="session" />



<% 
String inputData = request.getParameter("inputdata");
String machine = request.getParameter("machine");

String webUser = "webrun2";
String webGroup = "webrun2";

  //instantiate CT utilities.
ccm.ct.util.CTUtilities ccmut = new ccm.ct.util.CTUtilities();

String userName = storeInfo.getUserName();

  // get the IBM PC stuff out (i.e., ^M, and ^Z)	
inputData = ccmut.skipChars(inputData, "\r\u001a");

String projDir = storeInfo.getProjectPath(); 
System.err.println("User Project Dir=" + projDir);

String inpFile = projDir + File.separator + "gaussian.inp";
System.err.println("User input file=" + inpFile);
  

  // create file with inputData
ccmut.StringToFile(request, application, inpFile, inputData);
System.err.println("inpFile in SubmitGaussianjob is  " + inpFile);

  // these data at some point will have to come from the user/machine/
  // and environment database.
String remDir = "/home/pse";
String remUser = "pse";

  // get a path to templates for gaussian
String tDir = ccmut.templateDir(application) + File.separator +
           "Gaussian" + File.separator;
System.err.println("Template dir for Gaussian is=" + tDir);

   // get project name from storage bean  
String projName = storeInfo.getProjectDescriptionName();
  System.err.println("GausSubm; ProjectDecritionName from bean: "+projName); 
  
   // Fill the hashtable with replacements for tags
   Hashtable tagsToReplace = new Hashtable(10);
   tagsToReplace.put("user",  userName);
   tagsToReplace.put("remdir",  remDir);
   tagsToReplace.put("projname",  projName);
   tagsToReplace.put("host",  machine);
   tagsToReplace.put("remuser",  remUser);
   tagsToReplace.put("wfserver",  request.getServerName());
//   tagsToReplace.put("port", Integer.toString(request.getServerPort()));
   tagsToReplace.put("port", "7180");

   // Process template by replacing tags with values in the hashtable
   String jobScriptSource = tDir+"job.script";
   String jobScriptProcessed = projDir + File.separator + "job.script";
   ccmut.processTemplateFile(jobScriptSource, jobScriptProcessed, 
                             tagsToReplace);

   // Create remote project directory, e.g., /home/pse/jkl/h2o2
   String remoteUserDir = remDir + "/" + userName;
   String LogIt = ccmut.execCommandOnBackend(machine, remUser, 
                  "mkdir "+remoteUserDir);
   String remoteProjectDir = remoteUserDir + "/" + projName;
   LogIt = LogIt + ccmut.execCommandOnBackend(machine, remUser, 
                  "mkdir "+remoteProjectDir);

   // Copy files from user project dir, to remoteProjectDir
   String aFile = projDir + File.separator + "job.script";
   LogIt = LogIt + ccmut.copyFileToBackend("pr", aFile, 
           remUser, machine, remoteProjectDir);
   aFile = projDir + File.separator + "gaussian.inp";
   LogIt = LogIt + ccmut.copyFileToBackend("pr", aFile, 
           remUser, machine, remoteProjectDir);

   // submit a job 
   String submissionCommand = "/usr/craysoft/nqe/bin/qsub";
   String statusCommand = "/usr/craysoft/nqe/bin/qstat -a -u " +
                          remUser;
   LogIt = LogIt + ccmut.execCommandOnBackend(machine, remUser,
                  "( cd " + remoteProjectDir+ "; " +
                  submissionCommand + " job.script )");
   LogIt = LogIt + ccmut.execCommandOnBackend(machine, remUser,
                   statusCommand);

   // replace <> chars in LogIt so it does not confuse XML parser
   // 
   LogIt = ccmut.replacePiece("<", "&lt;", LogIt);
   LogIt = ccmut.replacePiece(">", "&gt;", LogIt);

   // Create status file
   Date dateNow = new Date();
   String statusString = 
          "<event>\n" +
          "<eventType>submitted</eventType>\n" +
          "<eventTime>" + dateNow + "</eventTime>\n" + 
          "<eventHost>" + machine + "</eventHost>\n" +
          "<eventUser>" + userName + "</eventUser>\n" +
          "<eventRemoteUser>" + remUser + "</eventRemoteUser>\n" +
          "<eventRemoteDirectory>" + remoteProjectDir + 
                                  "</eventRemoteDirectory>\n" +
          "<eventAction>SubmitGaussianJob.jsp</eventAction>\n" +
          "<eventInfo>" + LogIt + "</eventInfo>\n" +
          "</event>\n";
   String statusFile = projDir + File.separator + "status.xml";
System.err.println("Status file="+statusString);
System.err.println("=========Status file name:"+statusFile);
   ccmut.StringToFile(request, application, statusFile, statusString);

   String commLog;  
   commLog = ccmut.execCommandLocally("chown -R " + webUser + " " + projDir);
   commLog = commLog + ccmut.execCommandLocally("chgrp -R " + webUser +
             " " + projDir);

   commLog = commLog + ccmut.execCommandLocally("chmod -R " +
             "ug+w " + projDir);

   System.err.println("SubmitGaussianJob: " + commLog); 

%>
<jsp:forward page="WaitForResults.jsp"/>
