<%@ page errorPage="/CCM/ErrorPage.jsp" language="java"
    session="true" import="java.io.*,ccm.ct.util.CTUtilities" 
 %>
<jsp:useBean id="storeInfo" class="ccm.ct.beans.StoreProjectInfoBean"
 scope="session" />

<% 
  // instantiate Code Tools utilities class
  ccm.ct.util.CTUtilities ctu = new ccm.ct.util.CTUtilities();

  String projPath = storeInfo.getProjectPath();
  String status = ctu.FileToString(request, application,
                               projPath + File.separator + "status.xml");
  int statusCode;
  int statusInfoStart;

  if((statusInfoStart = 
        status.indexOf("<eventType>finished</eventType>")) >= 0) {
    statusCode = 3;
    } 
  else if(( statusInfoStart = 
        status.indexOf("<eventType>started</eventType>")) >= 0) {
    statusCode = 2;
    } 
  else if(( statusInfoStart =
        status.indexOf("<eventType>submitted</eventType>")) >= 0) {
    statusCode = 1;
    } 
  else {
    statusCode = 0;
    }
%>
<html>
<head>
	<link rel="stylesheet" type="text/css" href="/SciPortal/styles/standard.css">
	<script type="text/javascript" src="/SciPortal/js/standard.js"> </script>
	<meta http-equiv="Keywords" content="SciPortal">
	<meta http-equiv="Descriptions" content="CCM - CT">
	<title>
	CCM Gaussian Template Input Form 1
	</title>

<!-- start reloading loop -->
<% if(statusCode < 3) {
%>
<SCRIPT LANGUAGE="JavaScript">
<!--
setTimeout('location.href = "WaitForResults.jsp"',1000*15);
// -->
</SCRIPT>
<%
}
%>

</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<%@ include file="/CCM/Copyright.html" %>
<hr size="10">
<br><br>

<div class="right">
	<form name="Helper">
		<input type="button" name="submit" value="help"
		onClick="showHelp('/SciPortal/CCM/CT/ASSISTANTPAGES/CThelp.html');">
        </form>
</div>
<hr size="10">

<% if(statusCode == 3) { %>
  <DIV STYLE="color: black"> 
    <H1>Gaussian Run Finished</H1>
  </DIV>
<% } else if (statusCode == 2) { %>
  <DIV STYLE="color: red"> 
    <H1>Gaussian is still running</H1>
  </DIV>
<% } else if (statusCode == 1) { %>
  <DIV STYLE="color: blue"> 
    <H1>Gaussian Job has been submitted</H1>
  </DIV>
<% } 


String projDir = storeInfo.getProjectPath();
System.err.println("Proj Dir=" + projDir);

String projName = storeInfo.getProjectDescriptionName();

File fileToShow = new File(projDir);

String canonicalPath = fileToShow.getCanonicalPath();
%>

<H1>Directory: <%= projName %></H1><BR><BR>
<%
   String[] fileNames = fileToShow.list();

      %>
<TABLE>
<%
      for(int i=0; i < fileNames.length; i++) {
        String fullName = canonicalPath + File.separator + fileNames[i];
        String relativeName = projName + File.separator + fileNames[i];
        String line = "<TR>\n<TD>";

        File item = new File(fullName);
        if(item.isDirectory()) {
          line = line + "<IMG SRC=\"/icons/folder.gif\" ALT=\"Directory\">";
          }
        else {
          line = line + "<IMG SRC=\"/icons/generic.gif\" ALT=\"File\">";
          }
        line = line + "</TD>\n<TD>&nbsp;</TD>\n<TD>";
        line = line + "<A HREF=\"ShowFile.jsp?file=" + relativeName + "\">" +
               fileNames[i] + "</A></TD>\n</TR>";
%>
        <%= line %>
<%
        }

%>

</TABLE>
<%
  // Retrieve the infolines  from status string
    int InfoStart = status.indexOf("<eventInfo>", statusInfoStart);
    int InfoEnd = status.indexOf("</eventInfo>", statusInfoStart);
    String InfoString = status.substring(InfoStart, InfoEnd+11);
    InfoString = ctu.replacePiece("\n\n\n", "\n", InfoString);
%>
   <H1>Log of commands at this stage<H1><BR>
<PRE>
<%= InfoString %> 
</PRE><BR>

</body>    
</html>




