<%@ page errorPage="/CCM/ErrorPage.jsp" %>
<% 
  String userName="";
  String user = request.getRemoteUser();
  if(user == null) 
    user = "Sorry, Basic Authentication does not work"; 
  userName = user;
%>
<jsp:useBean id="entry" scope="page" class="ccm.entry.EntryBean" />
<jsp:setProperty name="entry" property="userName" />
<html>
<head>
  <link rel="stylesheet" type="text/css" href="/SciPortal/styles/standard.css">
  <script type="text/javascript" src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="keywords" content="SciPortal">
  <meta http-equiv="Descriptions" content="CCM - Entry">
  <title>
    SciPortal Welcome Page for <%= userName %>
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<h1 class="bdr">
  <div class="center">
    The OSC SciPortal
    <br />Welcome to the Chemistry and Materials
    <br />Toolkits
  </div>
</h1>
<table border="0" class="left" cellspacing="20">
<tr>
  <td valign="top" align="left">
    <span style="color:brown; font-weight:bold; font-size:14pt;">
      Welcome 
      <%
      if(!(userName == null)) { 
        userName = entry.getUserName(user);
        out.println(userName);
      }
      else if(user == null)
        out.println("Unregistered user\n\n");
      %>
    </span>.
    &nbsp;&nbsp;&nbsp;&nbsp;
    <span style="color:red; font-weight:bold; font-size:12pt;">
    Current date and time is <script src="/SciPortal/js/todayDate.js"></script>
    </span>
    <p>
    The navigation buttons along the top allow you to select the next toolkit.
    </p>
    <table class="center" border="5">
    <tr>
      <td>
        <span class="highlight">
        <div class="center">PDT</div>
        <br />The Problem Description and Archiving Toolkit
        </span>
        <p>
        This button will connect you to the process to generate a description 
        of the problem you want to solve or access previous problem descriptions.
        </p>
      </td><td valign="top">
        <span class="highlight">
        <div class="center">CT</div>
        <br />The Code Toolkit
        </span>
        <p>
        This button will connect you to the process to create a request for 
        computational resources from a problem description.
        </p>
      </td><td valign="top">
        <span class="highlight">
        <div class="center">AT</div>
        <br />The Analysis Toolkit
        </span>
        <p>
        This button will allow you to perform selected simple analysis on 
        your output.
        </p>
      </td>
    </tr>
    </table>
  </td>
</tr>
</table>
</body>
</html>
