<%@ page errorPage="/CCM/ErrorPage.jsp" %>
<html>
<head>
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script type="text/javascript" src="/SciPortal/js/standard.js"> </script>
  <meta http-equiv="Keywords" content="SciPortal">
  <meta http-equiv="Descriptions" content="CCM - PDT">
  <title>
    CCM Advanced Track Problem Specification
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<h1 class="bdr">
  <div class="center">
    CCM Advanced Track 
    <br />Problem Specification
  </div>
</h1>
<hr size="10" />
<div class="center">
<form name="advancedTrack" method="get" action="/SciPortal/CCM/PDT/PDTdisplay.jsp">
<table cellspacing="4" cellpadding="4" border="2">
<tr>
  <td colspan="3">
    <div class="left">
      <p>
      <span class="left">Advanced Track Problem Specification.</span>
      <input class="right" type="submit" value="Accept"></input>
      </p>
    </div>
  </td>
</tr><tr>
  <td>
    <div class="right">
      <h2 class="center">Physical System (check one)</h2>
      <input type="button" name="submit" value="help" class="Help" 
        onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/systemHelp.html');">
      </input>
    </div>
    <select name="physicalSystem" size="4">
      <option selected>Gas Phase</option>
      <option>Bulk Periodic</option>
      <option>Interfaces</option>
      <option>Defects</option>
      <option>Adsorbates</option>
      <option>Solvation</option>
    </select>
  </td><td>
    <div class="right">
      <h2 class="center">Properties</h2>
      <input type="button" name="submit" value="help" class="Help" 
        onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/propertiesHelp.html');">
      </input>
    </div>
    <select name="macrp" size="4" multiple>
      <option selected>Energy</option>
      <option>Radiative</option>
      <option>Dynamic</option>
      <option>Structure</option>
    </select>
  </td><td>
    <div class="right">
      <h2 class="center">Propery Details</h2>
      <input type="button" name="submit" value="help" class="Help" 
        onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html');">
      </input>
    </div>
    <select name="dprop" size="4" multiple>
      <option selected>Electronic_Energy</option>
      <option>Classical_Energy</option>
      <option>UV_Spectra</option>
      <option>NMR_Spectra</option>
      <option>IR_Spectra</option>
      <option>Nonlinear_Optics</option>
      <option>Hyperfine_Coupling</option>
      <option>Rate_Constants</option>
      <option>Chemical_Reactions</option>
      <option>Phase_Transitions</option>
      <option>Optimized_Geometry</option>
      <option>Moduli</option>
      <option>Transition_States</option>
    </select>
  </td>
</tr><tr>
  <td>
    <div class="right">
      <h2 class="center">Size Options</h2>
      <input type="button" name="submit" value="help" class="Help" 
        onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/sizeHelp.html');">
      </input>
    </div>
    <select name="sizeOptions" size="4" multiple>
      <option selected>Small</option>
      <option>Medium</option>
      <option>Large</option>
      <option>Mesoscale</option>
    </select>
  </td><td>
    <div class="right">
      <h2 class="center">Simulation Rigor</h2>
      <input type="button" name="submit" value="help" class="Help"
        onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/rigorHelp.html');">
      </input>
    </div>
    <select name="rigorquer" size="4">
      <option selected>Low</option>
      <option>Medium</option>
      <option>High</option>
    </select>
  </td><td>
    <div class="right">
      <h2 class="center">Method Specification</h2>
      <input type="button" name="submit" value="help" class="Help"
        onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/methodsHelp.html');">
      </input>
    </div>
    <select name="methquer" size="4">
      <option selected>Semi Empirical</option>
      <option>Hartree Fock</option>
      <option>Density Functional Theory</option>
      <option>MP2+</option>
      <option>Coupled Cluster</option>
      <option>Multiconfigurational SCF</option>
      <option>Configuration Interaction</option>
      <option>Quantum Molecular Dynamics</option>
      <option>Classical Molecular Dynamics</option>
      <option>Classical Monte Carlo</option>
      <option>Molecular Mechanics</option>
      <option>Tight Binding</option>
      <option>Mixed Methods</option>
      <option>Solvation</option>
      <option>Embedded Cluster</option>
      <option>Bulk Chemical Kinetics</option>
    </select>
  </td>
</tr><tr>
  <td colspan="3">
    <span class="left">Title</span>
      <input class="right" type="text" name="problemTitle" size="30"></input>
  </td>
</tr><tr>
  <td colspan="3">
    <span class="left">Description</span>
    <textarea class="right" type="text" name="problemComments" rows="10" cols="50">
    </textarea>
  <td>
</tr>
</table>
</div>
</form>
<hr size="10" />
</body>
</html>
