<%
  String userName="";
  String user = request.getRemoteUser();
  if(user == null)
     user = "Sorry, Basic Authentication does not work";
  userName = user;
%>
<%@ page errorPage="/CCM/ErrorPage.jsp" %>
<jsp:useBean id="entry" scope="page" class="ccm.entry.EntryBean" />
<jsp:setProperty name="entry" property="userName" />

<% String [] problemNames; %>
<jsp:useBean id="problemDescription" class="ccm.pdt.EntryBean" scope="page" />
<html>
<head>
  <link rel="stylesheet" type="text/css" href="/SciPortal/styles/standard.css">
  <script type="text/javascript" src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="keywords" content="SciPortal">
  <meta http-equiv="Descriptions" content="CCM - PDT">
  <title>
    Problem Description Toolkit
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<h1 class="bdr">
  Problem Description Toolkit
</h1>
<div class="right">
<form class="NAV" name="helpform">
  <input type="button" name="submit" value="help" 
    onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/PDThelp.html');">
  </input>
</form>
</div>
<p>
<strong>Select an existing problem description from the list below;
or create a new problem description (by clicking the new button).</strong>
</p>
<p>
Problem Description List for
<%
  userName = entry.getUserName(user);
  out.print(userName + ".");
%>
</p>
<% 
  String me = request.getRemoteUser();
  problemDescription.setUserName(me);
  problemDescription.parseOption("list");
  problemNames = problemDescription.getLp();
  int nc = problemNames.length;
%>
<table border="0" cellspacing="5">
<tr>
  <td align="right" valign="baseline">
    <%
      String aName = problemNames[0];
      if(nc == 0){
    %>
    <p class="center">
    ERROR number of problems in thelist is zero ERROR!!
    </p>
    <%
      } else if((nc == 1) && (aName.equals("null"))){
    %>
    <form class="NAV" method="get" action="/SciPortal/CCM/PDT/PDTnew.html">
      <input type="button" name="option" value="new"></input>
    </form>
  </td><td align="right">
    <p class="center">
    There are no existing problem descriptions defined.
    <br />Please use the <strong>"new"</strong> button to create one.
    </p>
    <%
      } else {
    %>
    <div class="left">
    <form method="get" action="/SciPortal/CCM/PDT/maintenanceHandler.jsp">
    <%
        for(int i = 0; i < nc; i++) {
          out.println("<br />"); 
          out.print("\t\t\t<input type=\"radio\""
            + " name=\"problemDescriptionName\""); 
          out.println(" value=\"" + problemNames[i] 
            + "\">&nbsp;&nbsp;<span class=\"pN\">" 
            + problemNames[i] + "</span>");
        }
      }
    %>
    <br /><br />
    <input class="NAV" type="submit" name="option" value="select"></input>
    </form>
    </div>
  </td>
</tr>
</table>
<br />
<p>
<form method="get" action="/SciPortal/CCM/PDT/PDTnew.html">
<strong>Or, use the "new" button to create a new problem description.</strong>
&nbsp;&nbsp;
<input class="NAV" type="submit" name="option" value="new"></input>
</form>
</p>
</body>
</html>
