<%@ page errorPage="/CCM/ErrorPage.jsp" %>
<html>
<head>
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script type="text/javascript" src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="Keywords" content="SciPortal">
  <meta http-equiv="Descriptions" content="CCM - PDT">
  <title>
    CCM Problem Description FORM 3
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<h1 class="bdr">
  Detailed Property Specification
</h1>
<div class="right">
  <form name="Helper">
    <input type="button" name="submit" value="help" 
      onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html');">
  </form>
</div>
<hr size="10" />
<h1 class="center">Detailed Properties</h1>
<p>
In this section, you should specify one or more detailed 
properties to study in the simulation.
</p>
<form name="prpdquer" method="get" action="/SciPortal/CCM/PDT/USERp4.jsp">
<table cellspacing="0" class="center">
<tr bgcolor="#87cefa">
  <td valign="top">
    <div class="left">
      <input type="submit" value="Accept"></input>
    </div>
    <br /><br />
    <select name="dprop" size="15" multiple>
      <option selected>Electronic_Energy</option>
      <option>Classical_Energy</option>
      <option>UV_Spectra</option>
      <option>NMR_Spectra</option>
      <option>IR_Spectra</option>
      <option>Nonlinear_Optics</option>
      <option>Hyperfine_Coupling</option>
      <option>Rate_Constants</option>
      <option>Chemical_Reactions</option>
      <option>Phase_Transitions</option>
      <option>Optimized_Geometry</option>
      <option>Moduli</option>
      <option>Transition_States</option>
    </select>
  </td><td bgcolor="#87cefa" valign="top">
    <h1 class="center">Click for<br>assistance.</h1>
    <form>
    <table border=0>
    <tr>
      <td>
        <div class="left">
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#ELS');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Electronic Structure
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#CLE');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Classical Energy
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#UVS');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          UV Spectra
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#NMR');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          NMR Spectra
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help" 
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#IRS');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          IR Spectra
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help" 
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#NLO');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Nonlinear Optics
        </div>
      </td><td>
        <div class="left">
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#HFC');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Hyperfine Coupling
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#RCN');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Rate Constants
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help" 
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#CHR');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Chemical Reactions
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#PHT');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Phase Transitions
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#OPG');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Optimized Geometry
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#MOD');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Moduli
          <br /><br />
          <sup><input type="button" name="submit" value="HELP" class="Help"
            onClick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/detailsHelp.html#TRS');"></input></sup>
          &nbsp;&nbsp;&nbsp;&nbsp;
          Transition States
        </div>
      </td>
    </tr>
    </table>
    </form>
  </td>
</tr>
</table>
</form>
<hr size="10" />
</div>
</body>
</html>
