<%@ page errorPage="/CCM/ErrorPage.jsp" session="true" %>
<jsp:useBean id="storeInfo" class="ccm.ct.beans.StoreProjectInfoBean" scope="session">
  <% 
    String user = storeInfo.getUserName();
    String projectName = storeInfo.getProjectDescriptionName();
    String track = storeInfo.getTrack(); 
  %>
</jsp:useBean>
<html>
<head>
  <link rel="stylesheet" href="/SciPortal/styles/standard.css">
  <script type="text/javascript" src="/SciPortal/js/standard.js"></script>
  <meta http-equiv="Keywords" content="SciPortal">
  <meta http-equiv="Descriptions" content="CCM - PDT">
  <title>
    CCM Problem Description FORM 6
  </title>
</head>
<body bgcolor="#f2fae4" background="/SciPortal/CCM/ccmImages/bg1x.jpg">
<jsp:include page="/CCM/Copyright.html" flush="true" />
<% 
  String user = storeInfo.getUserName();
  String projectName = storeInfo.getProjectDescriptionName();
  String track = storeInfo.getTrack(); 
%>
<h1 class="bdr">
  Method Specification
</h1>
<div class="right">
  <form name="Helper">
    <input type="button" name="submit" value="help" 
      onclick="showHelp('/SciPortal/CCM/PDT/ASSISTANTPAGES/methodsHelp.html');">
    </input>
  </form>
</div>
<hr size="10" />
<form name="methquer" method="get" action="/SciPortal/CCM/CT/CTentry.jsp">
<table cellspacing="0" cellpadding="10" width="750"> 
<tr valign="top">
  <td valign="top">
    <div class="left">
      <input type="submit" name="submit" value="Accept"></input>
      <br /><br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
           onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#SE.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth1" value="1" checked>Semi Empirical</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#HF.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth2" value="2" >Hartree Fock</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#DF.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth3" value="3">Density Functional Theory</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#MP.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth4" value="4">MP2+</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#CC.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth5" value="5">Coupled Cluster</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#MS.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth6" value="6">Multiconfigurational SCF</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#CI.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth7" value="7">Configuration Interaction</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#QD.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth8" value="8">Quantum Molecular Dynamics</input>
    </div>
  </td><td width="40%">
    <div class="left">
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#MD.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth9" value="9">Classical Molecular Dynamics</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#MC.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth10" value="10">Classical Monte Carlo</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#MM.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth11" value="11">Molecular Mechanics</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#TB.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth12" value="12">Tight Binding</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#MX.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth13" value="13">Mixed Methods</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#SL.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth14" value="14">Solvation</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#EC.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth15" value="15">Embedded Cluster</input>
      <br /><br />
      <sup><input type="button" name="submit" class="Help" value="HELP" 
            onClick="showHelp('/SciPortal/ccmPDT/assistantPages/methodsHelp#CK.html');">
      </input></sup>
      &nbsp;&nbsp;&nbsp;&nbsp;
      <input type="checkbox" name="meth16" value="16">Bulk Chemical Kinetics</input>
    </div>
  </td>
</tr>
</table>
</form>
<hr size="10" />
</div>
</body>
</html>
