package WebFlow.ATD;
import WebFlow.*;
import WebFlow.submitJob.*;
import WebFlow.xml.*;
import WebFlow.ATD.*;
import WebFlow.event.*;
import org.omg.CORBA.*;
import org.w3c.dom.*;
import com.ibm.xml.parser.ExternalID;
import com.ibm.xml.parser.Parser;
import com.ibm.xml.parser.TXDocument;
import com.ibm.xml.parser.DTD;
import java.io.*;
import java.util.*;
import java.net.*;
import java.awt.*; 
import java.awt.event.*; 
import javax.swing.*;
public class CommandLineFinding extends JFrame {

private static Parser parser;
private static Document doc;
public String[] piplist;
public String[] poplist;

private static String Fname="";
private static String FADname="";
private static  String Command="", args1,args2; 
public static String RSL;
public static String InstallRSL;
public static submitJob submit;
public static XmlServer xmlserver;
public static XmlATD Atd;

private static WebFlowContext ws;
private static org.omg.CORBA.Object p1,p2,p3;
private static  DTD dtd;
private  JTextField xmlfilename;
private JTextArea textarea;
private JButton Submit;
private JPanel MainPanel,Main1Panel, XMLPanel, SubmitPanel;
private  String XmlFileName="";


  public static void main(String args[])
  {
    Fname= args[1];
    args1=args[2];
    args2=args[3];
    System.out.println("the name="+ Fname);
    // to submit command line.
    if (connected(args))
      {            
	CommandLineFinding app = new CommandLineFinding(Fname); //calling the Command finding frame
	app.addWindowListener(
			      new WindowAdapter(){
	  public void windowClosing(WindowEvent e){
	    ws.detachPushEvent(p1,"submit",p3,"submit"); 
	    ws.removeModule(p1);
	    ws.removeModule(p3);
	    System.exit(0);
	  }
	}
			      );
	
      }
    else{
      System.out.println("connection failed"); 
    }
  };





   public CommandLineFinding(String FileName)
   {
     super( "Abstract Task Descriptor" );
     this.XmlFileName=FileName;
     FlowLayout layout;  
     System.out.println("Entering the ATDFrame.....");
     // layout = new FlowLayout();
     layout = new FlowLayout();
     getContentPane().setLayout( layout );
     
     XMLPanel=new JPanel();
     XMLPanel.setLayout( new GridLayout(2,1) );
     XMLPanel.add( new JLabel( "Please Enter the XML file Name:" ) );
     XMLPanel.add(xmlfilename= new JTextField(XmlFileName));
     // xmlfilename.setText(XmlFileName);
     
     SubmitPanel=new JPanel();
     SubmitPanel.setLayout( new GridLayout(1,1) );
     Submit=new JButton (" Submit ");
     Submit.addActionListener(
			      new ActionListener() {
       public void actionPerformed( ActionEvent e )
	 {
	   String ButtonName = e.getActionCommand();
	   String  XmlFileName=xmlfilename.getText();
	   if(ButtonName.equals(" Submit "))
	     { 
	       XmlFileName=xmlfilename.getText();
	       if(Atd.instantiateParser(XmlFileName))// read ATD.xml file
		 {          
		   FADname=Atd.GetADFileName();  // to find out the AD.xml file name
		   System.out.println("This XML file is: "+ FADname);
		   
		   if(Atd.instantiateParser(FADname)) //Parse the AD.xml File
		     {
		       System.out.println("Entering to find command line ");
		       Command= Atd.getCommandLine(args1, args2); //find a command Line
		       System.out.println("This Command Line is: "+ Command);
		       submit.submitLocally(Command); //submit the commandline to server.
		       System.out.println("Submit finishing");
		     }
		 }
	       else 
		 {
		   System.out.println("This XML file is not exited!");
		   System.out.println("Finish the  submit command "); 
		   //   ws.removeModule(p1);
		   // ws.removeModule(p2);
		   // ws.removeModule(p3);
		 }
	     }
	 }
     }
			      );
     
     SubmitPanel.add(Submit);

     Main1Panel=new JPanel();
     Main1Panel.setLayout( new BorderLayout() );
     Main1Panel.add(XMLPanel, BorderLayout.CENTER );
     Main1Panel.add(SubmitPanel, BorderLayout.SOUTH);
     getContentPane().add(Main1Panel);
    
     setSize( 300, 200 );
     show();
   };
 
  


 public static boolean connected(String args[]){
      try
      {
       //  Create ORB
        Properties props = System.getProperties();
        props.put("org.omg.CORBA.ORBClass", "com.ooc.CORBA.ORB");
        props.put("org.omg.CORBA.ORBSingletonClass", "com.ooc.CORBA.ORBSingleton");
         System.setProperties(props);
         ORB orb = ORB.init(args, props);
         String masterURL = args[0] ; 
         String ref ; 
         org.omg.CORBA.Object obj = null ; 
         System.out.println(" masterURL : "+masterURL); 
         ref = getIORFromURL(masterURL);
         System.out.println("REF: "+ref); 
         obj = orb.string_to_object(ref); 
         if(obj == null)
              throw new RuntimeException(); 
         ws =  WebFlowContextHelper.narrow(obj); 
         System.out.println("Clinet: got master "+ws);
         if(ws == null)
              throw new RuntimeException();  
         System.out.println("attach submitJob new------------------------");                p1 = ws.addNewModule("submitJob");
         submit = submitJobHelper.narrow(p1); 
 if(p1==null){ System.out.println("p3 is null------------");}
       	 submit.test(); 
        
         System.out.println("attach XmlATD------------------------");
         p3 = ws.addNewModule("XmlATD");
         if(p3==null){ System.out.println("p3 is null------------");}
         System.out.println("narrow XmlATD------------------------"); 
         Atd = XmlATDHelper.narrow(p3);
         Atd.test();
        
	 // System.out.println("attach XmlServer------------------------"); 
	 // p2 = ws.addNewModule("XmlServer");
         //System.out.println("narrow XmlServer------------------------"); 
         //xmlserver = XmlServerHelper.narrow(p2);
	 // xmlserver.test();
         }
       catch(COMM_FAILURE ex)
	   {
          System.out.println("Command_Error: "+ex);
          System.err.println(ex.getMessage());
          ex.printStackTrace(); 
        		   System.exit(1); 
	   } 
    return true;
 };

static public String getIORFromURL(String url) {
    System.out.println("Slave WebFlow is getting IOR from url:"+url);
    String masterServerIOR =""; 
    String thisLine = null ;
   // Open the URL for reading
    try{
         URL u = new URL(url);       
        try{
         DataInputStream theHTML = new DataInputStream(u.openStream());
         while((thisLine = theHTML.readLine()) != null){ 
         masterServerIOR += thisLine ;      } 
        }
        catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
        }
     }
     catch(Exception e){
          System.out.println("configReader:getIORfromURL:"+e);
     }
    return masterServerIOR ; 
  }



};

	
