import javax.swing.*;
import java.awt.event.*;
import java.awt.*;

public class ATDMainBK extends JFrame {
   public ATDMainBK(final String[] hosts)
   {
      super( "Using a JDesktopPane" );

      JMenuBar bar = new JMenuBar();
      JMenu addMenu = new JMenu( "Add" );
      JMenuItem newFrame = new JMenuItem( "Internal Frame" );
      addMenu.add( newFrame );      
      bar.add( addMenu );
      setJMenuBar( bar );      

      final JDesktopPane theDesktop = new JDesktopPane();
      getContentPane().add( theDesktop );
    
      newFrame.addActionListener(
         new ActionListener() {
            public void actionPerformed( ActionEvent e ) {
                ATDFrameBK f = new ATDFrameBK(hosts);
                f.setBounds(0,0,600,500);
                theDesktop.add(f);
            }
         }
      );

      setSize( 800, 700 );
      show();
   }

   public static void main( String args[] )
   {     
     ATDMainBK app = new ATDMainBK(args);

      app.addWindowListener(
         new WindowAdapter() {
            public void windowClosing( WindowEvent e )
            {
               System.exit( 0 );
            }
         }
      );
   }
}

