package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.Base64.*;
import WebFlow.*;
import WebFlow.event.*;
import WebFlow.ContextManager.*;
import org.omg.CORBA.*;
import java.util.*;
import java.text.*;


public class listProblems extends HttpServlet{

  
  private String userName; 
  ServletOutputStream out;

	public void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {

        String auth = req.getHeader("authorization");
        StringTokenizer st = new StringTokenizer(auth);
        String copa = st.nextToken();
        copa = st.nextToken();
        Base64Decoder decoder = new Base64Decoder(copa);
        try {
          String decoded = decoder.processString();
          StringTokenizer st1 = new StringTokenizer(decoded,":");
          userName = st1.nextToken();
        } catch (Exception e) {
          System.err.println("cannot decode "+copa);
          System.err.println(e);
        } 

  ContextManager cm = ServerServlet.getContextManager(userName);         
  String[] lp = cm.listProblems();
  int nc = lp.length;
  System.out.println("# of contexts = "+nc);
    
  out = res.getOutputStream();
  res.setContentType("text/html");

  out.println("<html>");
  out.println("\t<TITLE>");
  out.println("\t\tPSE Problem List Page");
  out.println("\t</TITLE>");

  /*
  out.println("<SCRIPT>");
  out.println(" function submitForm(argument) {");
  out.println("  document.testform.action='/SciPortal.servlet.WebFlow.Servlets.Form21?action='+argument;");
  out.println("  document.testform.method='GET';");
  out.println("  document.testform.submit();");
  out.println("  return true;");
  out.println("  }"); 
  out.println("</SCRIPT>");  
  */

  out.println("</HEAD>");
  out.println("<BODY STYLE=\"color:black;\" BGCOLOR=\"#f2fae4\" BACKGROUND=\"/SciPortal/ccmImages/bg1x.jpg\">");
  out.println("<H1 ALIGN=\"center\">List of Existing Problem Descriptions</H1>");
  out.println("<DIV ALIGN=\"right\">");
  out.println("\t<FORM NAME=\"helpform\">");
  out.println("\t\t<INPUT TYPE=\"button\" NAME=\"submit\" VALUE=\"help\" onClick=showHelp(\"\")>");
  out.println("\t</FORM>");
  out.println("</DIV>");
  out.println("<P><B>Select an existing problem description from the list below;</B>");
  out.println("<B>or create a new problem description (by clicking the new button).</B>\n</P>");
  out.println("<DIV>");          
  out.println("\t<FORM NAME=\"testform\" METHOD=\"GET\" ACTION=\"/SciPortal.servlet.WebFlow.Servlets.Form21\">");
  out.println("\t\t<INPUT TYPE=\"hidden\" NAME=\"page\" VALUE=21>");

  if(nc>0) {
      for(int i=0; i<nc; i++) {
        String aName = lp[i];
        out.println("<BR>"); 
        out.println("<INPUT TYPE=\"radio\" NAME=\"ProjectContextName\" VALUE=\""+lp[i]+"\"> "+aName);
      }
    		}
    		else {
         		out.println("<P ALIGN=\"center\">");
         		out.println("There are no existing problem descriptions defined.<BR>");
         		out.println("Please use \"new\" button to create one"); 
         		out.println("</P>");
    		}
  out.println("<P><CENTER>");
  out.println("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"new\">");
  out.println("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"select\">");
  out.println("<INPUT TYPE=\"submit\" NAME=\"option\" VALUE=\"delete\">");
  out.println("<INPUT TYPE=\"button\" NAME=\"submit\" VALUE=\"archive\" onClick=\"alert(\'not supported\')\">");

  out.println("</CENTER>"); 
  out.println("</FORM>");
  out.println("</BODY>");    
  out.println("</HTML>");

  out.flush();
  out.close();

  }

  void error(String msg){
    out.println(msg);
  }

  void status(String msg){
    out.println(msg);
  }

  public String getServletInfo(){
    return "By T. Haupt and K. Flurchick";
  }

}



