package WebFlow.Servlets;

import java.io.*;
import javax.servlet.*;
import javax.servlet.http.*;
import WebFlow.*;
import WebFlow.event.*;
//import WebFlow.Charon.*;
import org.omg.CORBA.*;
//import WebFlow.QS.*;
//import WebFlow.hashtable.*;
import java.lang.reflect.*;
//import WebFlow.PSEscript;
import java.util.*;
                               
public class stopWFSM extends HttpServlet {
  private ORB orb;
  private WebFlowContext ws = null;
  PrintWriter out;
  private String ior;
  private WebFlowContext masterServer;
  private boolean notReady;
  private int icount;
  private final String masterIOR="/usr/local/apache_t3.1/htdocs/SciPortal/IOR/master.txt";
  private String masterRef;

  protected void doGet(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {
        doPost(req, res);
  }


  protected void doPost(HttpServletRequest req, HttpServletResponse res)
                       throws ServletException, IOException {

    System.out.println("servlet started");
    out = res.getWriter();
    res.setContentType("text/html");
    out.println("<head>");
    out.println("<title>stopWFS</title>"); 

    out.println("</head>");
    out.println("<body bgcolor=\"white\">");
    out.println("<center>");
    out.println("<h3> stopWFS</h3>");
    out.println("</center>");
    out.println("<p>");

    error("stop WebFlowServer<br>");

    String[] args = new String[1];
    args[0]=req.getParameter("config");    


    notReady=true;
    /* first check whether the server is already running */
    masterRef = ReadIORFromFile(masterIOR);
    if(masterRef.length()>10) {
        try {
              orb = ServerServlet.orb;
              if(getMaster(masterRef)) {
                 if(pingServer(masterServer)) notReady=false;
	      }
	} catch (java.lang.NullPointerException npe) {} 
    }


  out.flush();
  if(!notReady) {
      /* kill the server */

      try{ 
        System.out.println("removeMyself");
        masterServer.removeMyself();
        waitFor(1000);   
        System.out.println("removeMyself done");
      } catch (Exception e) {
          out.println("WebFlow server is not responding<br>");
      }
  }      

    out.flush();
    out.println("WebFlow server is shut down!");
    out.println("</body>");    
    out.println("</html>");
    System.out.println("about to flush");
    out.flush();
    out.close();
  }

  void error(String msg)
  {
    out.println(msg);
  }

  void status(String msg)
  {
    //out.println(msg);
  }
                              
  public String getServletInfo()
  {
  return "By T. Haupt";
  }

    public synchronized void waitFor(long howLong) {
	try {
              wait(howLong);
	} catch (Exception e) {System.err.println(e);}
    }

  public String ReadIORFromFile(String masterIOR)   {
      //open a file
      FileInputStream theFile;
      BufferedReader fileReader;
      String sObjRef;

      try {
           theFile=new FileInputStream(masterIOR);
           fileReader=new BufferedReader(new InputStreamReader(theFile));
      }
      catch(FileNotFoundException e){
           return "";
      }

      //read a reference string
      try {
        sObjRef=fileReader.readLine();
        System.err.println("Got the reference: "+sObjRef);
      }
      catch (IOException e) {
        return "";
      }
      
      try {
        theFile.close();
        fileReader.close();
      }
      catch (IOException e) {}

      //return the reference string
      return sObjRef;
  }

    public boolean getMaster(String MasterRef){
       org.omg.CORBA.Object ws = orb.string_to_object(MasterRef);
       if(ws==null) return false;
       masterServer = WebFlowContextHelper.narrow(ws);
       if(masterServer==null) return false;
       else return true;
    }

    public boolean pingServer(WebFlowContext ws) {
	boolean non_exist = true;
	try{
	    non_exist = ws._non_existent();
	}
        catch(org.omg.CORBA.COMM_FAILURE ex){}
	catch(org.omg.CORBA.OBJECT_NOT_EXIST ex){}

        return !non_exist;
    }       

}




