package ccm.test;

import java.io.*;
import java.text.*;
import java.util.*;
import javax.servlet.*;
import javax.servlet.http.*;

/**
 * The simplest possible servlet.
 *
 * @author James Duncan Davidson
 */

public class ListRuntimeEnvironment extends HttpServlet {

    public void doGet(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        response.setContentType("text/html");
        PrintWriter out = response.getWriter();

        out.println("<html>");
        out.println("<head>");

	String title = request.getRemoteUser();

	out.println("<title>" + title + "</title>");
        out.println("</head>");
        out.println("<body bgcolor=\"yellow\">");
        out.println("<H1>Hello " + title + "</H1><BR>");

        Runtime rt = Runtime.getRuntime();
        String command = "env";
	StringBuffer stdoutAndStderr = new StringBuffer();

	try {
	    Process pCommand = rt.exec(command);
            Process p = rt.exec(command);
	    InputStream commandStdout =  pCommand.getInputStream();
	    InputStream commandStderr =  pCommand.getErrorStream();

	    int c;
	    stdoutAndStderr.append("<BR>\nSTDOUT:<PRE>\n");
	    while((c = commandStdout.read()) != -1) {
		stdoutAndStderr.append((char)c);
	    }
	    commandStdout.close();
	    stdoutAndStderr.append("</PRE>\nSTDERR:<PRE>\n");
	    while((c = commandStderr.read()) != -1) {
		stdoutAndStderr.append((char)c);
	    }
	    commandStderr.close();
	    stdoutAndStderr.append("</PRE>\n");
	}
	catch (IOException eio) {
            System.err.println(eio.getMessage());
            eio.printStackTrace();
	}

        out.println("Unix command:" + command + " produced:<BR>");
        out.println(stdoutAndStderr.toString()); 
        out.println("</body>");
        out.println("</html>");

    }
}




