import java.awt.*;
import java.awt.event.*;
import java.net.*; 
import java.io.*; 
import java.security.*; 
import com.sun.net.ssl.*; 
import javax.net.ssl.*; 
import javax.security.cert.*; 
import javax.net.*; 
import WebFlow.Base64.*;

public class clientFrame extends Frame {

TextArea outputTA;
TextField userID, passwd, urlTF;
javax.net.ssl.SSLSocketFactory sf;
javax.net.ssl.SSLSocket sock;
X509TrustManager tm;
KeyManager[] km;
SSLContext sc;

  public clientFrame() {
   super("HTTPS client with Basic Authentication");
   setLayout(new BorderLayout());
   
   Panel p = new Panel();
   p.setLayout(new BorderLayout());
   Label urlLabel = new Label("location: ");
   urlTF = new TextField("https://heechee.osc.edu:7143/SciPortal/IOR/master.txt");
   p.add(urlLabel, BorderLayout.WEST);
   p.add(urlTF, BorderLayout.CENTER);
   add(p, BorderLayout.NORTH);

   outputTA = new TextArea(20,8);
   add(outputTA, BorderLayout.CENTER);


   ActionListener bListener = new ActionListener() {
     public void actionPerformed(ActionEvent e) {
       String what = e.getActionCommand();
       if(what.equals("submit")) {
           String a = getAuthorization();
           SubmitRequest(urlTF.getText(),a);
       }
       else {
           System.exit(0);
       }           
     }
   };


   Panel sp = new Panel();
   sp.setLayout(new GridLayout(2,3));
   userID = new TextField();
   passwd = new TextField();
   passwd.setEchoChar('*');
   Button b1 = new Button("submit");
   b1.addActionListener(bListener);
   Button b2 = new Button("exit");
   b2.addActionListener(bListener);

   sp.add(new Label("User ID :",Label.CENTER));
   sp.add(userID);
   sp.add(b1);
   sp.add(new Label("Password :",Label.CENTER));
   sp.add(passwd);
   sp.add(b2);

   add(sp, BorderLayout.SOUTH);

   java.security.Security.addProvider
                            (new com.sun.net.ssl.internal.ssl.Provider()); 
   System.setProperty("java.protocol.handler.pkgs", 
                                  "com.sun.net.ssl.internal.www.protocol"); 
   sf = (javax.net.ssl.SSLSocketFactory) 
                               javax.net.ssl.SSLSocketFactory.getDefault(); 
   sock = null;    


  }

  public void SetOutputText(String what) {
   outputTA.append(what);
  } 

  public void SubmitRequest(String what, String authorization){
     try { 
           tm = new MyX509TrustManager(); 
           km = null; 
           TrustManager[] tma = {tm}; 
           sc = SSLContext.getInstance("SSL"); 
           sc.init(km,tma,new java.security.SecureRandom()); 
           SSLSocketFactory sf1 = sc.getSocketFactory(); 
           HttpsURLConnection.setDefaultSSLSocketFactory(sf1);

           URL verisign = new URL(what); 
           HttpsURLConnection con = (HttpsURLConnection)verisign.openConnection();
	   //con.setRequestProperty("authorization","Basic cHNlOjB1clBTRQ=="); 
           con.setRequestProperty("authorization",authorization); 
           InputStream is = con.getInputStream();
           BufferedReader in = new BufferedReader(new InputStreamReader(is)); 
           String inputLine; 
           while ((inputLine = in.readLine()) != null) 
                SetOutputText(inputLine+"\n"); 
                in.close(); 
           } 
           catch (Exception e) { 
                System.err.println("Exception " + e); 
           } 
  } 

  public String getAuthorization() {
     String what = userID+":"+passwd;
     System.out.println(what);
     Base64Encoder b = new Base64Encoder(what);
     String encoded = b.processString();
     return encoded;     
  }

}




