package EDU.syr.npac.Gateway;

   import org.omg.CORBA.*;
   import java.awt.*;
   import java.awt.event.*;
   import java.applet.*;
   import javax.swing.*; 
   import java.net.*;
//   import EDU.syr.npac.frontend.*;
   import WebFlow.*;
   import WebFlow.event.*;
   import WebFlow.xml.*;
   import WebFlow.gscript.*;
   import WebFlow.hashtable.*;
   import WebFlow.RemoteFile.*;
   import WebFlow.submitJob.*; 
   import WebFlow.FileBrowser.*;
   import WebFlow.ccm.*; 
   import java.io.*;
   import java.net.*;
   import java.util.*;

   public class gw extends JApplet
   {
      private int appCount_ = 0;
      private ORB orb;

     // master IOR stuff
      public String relMasterIOR;  //where master IOR is stored
      public String IorUrl;        //URL of master IOR
      public String IOR;
      public String jhost;
      public String jport;

     // contexts 
      private WebFlowContext ws = null;
      public WebFlowContext uc= null;
      private WebFlowContext ProjectContext = null;
      private WebFlowContext SessionContext = null;
      private WebFlowContext ApplContext = null;
      private String ProjectName, SessionName, ApplicationName;
      private String ProjContextName, SessionContextName, ApplContextName;
      public String UserName;

     //for manipulations with contexts (will be moved to server side)
      private Vector ProjContextList, ProjContextNames;
      private Vector SessionContextList, SessionContextNames;

     // context data
      private ContextData UserContextData;
      private ContextData ProjectContextData, SessionContextData;
      private ContextData ApplicationContextData;
      private String curDir;      // directory to save context data
      public Date currentDate;    // time stamp
      public long time;           // as above, serialized 

     // modules  
      private org.omg.CORBA.Object oxml,ohash,og,os,orf,osc,ofb; 
      private String ContextDataIOR, gScriptIOR, XmlServerIOR;
      private String submitJobIOR, RemoteFileIOR, SaveContextIOR;
      private String FileBrowserIOR;
      private gScript gscript;
      private XmlServer parser;
      private submitJob submit;
      private RemoteFile remotefile;
      public SaveContext saveContext;
      private FileBrowser filebrowser;

     // for servlet output processing
      private Hashtable HTMLform;
      private int FormLength;
      private String[] FormElementNames;
      private String[] FormElementValues;
      private int currentPage;    // servlet's ID
      private String pageurl;     // String: URL of servlet to be called
      private String codeType;
      private String viewType;
      private URL docURL;         // above converted to java object URL
      public AppletContext ac;    // used to call the servlet
      private String appl;        // application descriptor (XML)  
      private String inputFile;   // file name selected by the user 

     // control applet GUI (ignore for now)
      private CardLayout card = new CardLayout();
      public JPanel  cP;
      private navigator nv;
      public String Display;  

     // for multihost case (ignore for now) 
      private JTextField hostLabel,contextLabel; 
      private String hostname,rootname;
      public static String[] hostnames;       
      public int rootCard;
      public String[] fileRoot;
      public boolean[] connectedHosts;
      public TabbedPane[] cards;
      private Hashtable Slaves;
      private Hashtable ht;
      public String ServletDir="http://heechee.osc.edu:8002/servlet/";
      public String DDir = "/home/webflow/Jigsaw/Jigsaw/WWW/DESCRIPTORS/";

	//kenf - class variables
	private String PSEdir="http://heechee.osc.edu:8002/PSE/";
	private String ATdir="http://heechee.osc.edu:8002/Analysis/";
	public String subpage="";    // servlet's sub page ID for a sequence of pages
	private ccm ccm101;
	//kenf - end of class variables

     // misc
      private int n;
      private boolean debug=true;
      private boolean isOK;
      Vector jobVector, jobContexts;
      int jobIndex;
      String userDir;
      String fName, selectedFile;
 
      public void init() {

      jobVector = new Vector();
      jobContexts = new Vector();

      Slaves = new Hashtable();
      ProjContextNames = new Vector();
      SessionContextNames = new Vector();

      n=4;
      hostnames = new String[n];
      hostnames[0] = "heechee.osc.edu";
      hostnames[1] = "osprey3.npac.syr.edu";
      hostnames[2] = "osprey4.npac.syr.edu";
      hostnames[3] = "osprey7.npac.syr.edu";

      fileRoot = new String[n];
      fileRoot[0]="/tmp";
      fileRoot[1]="/tmp";
      fileRoot[2]="/npac/home/webflow/QSData";
      fileRoot[3]="/tmp";

      HTMLform = new Hashtable(); 

      ht = new Hashtable();
      for (int i=0; i<4; i++) {
	  System.out.println("add entry to ht: " + gw.hostnames[i]);
	  ht.put(gw.hostnames[i],new Integer(i));
      } 



      connectedHosts = new boolean[n];
       
      String UC = getParameter("userContext");
      if(UC == null) {
         System.err.println("user name not defined.");
         stop();
      }
      else {
         UserName = UC;
         System.err.println("user name = "+UserName);
      } 

      jhost = getParameter("jhost");
      jport = getParameter("jport"); 
      relMasterIOR = "/"+getParameter("relMasterIOR");

      rootname = getParameter("host");
      hostname = rootname;

      Display = getParameter("DISPLAY");
      System.out.println("Display set to: "+Display);

      IorUrl = "http://"+jhost+":"+jport+relMasterIOR;
      System.out.println("IorUrl = "+IorUrl); 

      for(int i=0; i<n; i++) {
        if(hostnames[i].equals(rootname)) {
           connectedHosts[i]=true;
           rootCard=i;
	}
        else {
           connectedHosts[i]=false;
	}
      }

      orb = ORB.init(this, new java.util.Properties());
      setUserContext(IorUrl,UC);

      org.omg.CORBA.Object occm = uc.addNewModule("ccm");
      ccm ccm101 = ccmHelper.narrow(occm);
	
      ccm101.test(); //kenf testing ccm module


      /* add XML server */
      oxml = uc.addNewModule("XmlServer");
      XmlServerIOR=orb.object_to_string(oxml);
      parser = XmlServerHelper.narrow(oxml);
      parser.test();
      /* add UserHashtable */
      ohash = uc.addNewModule("ContextData");
      ContextDataIOR = orb.object_to_string(ohash);
      UserContextData = ContextDataHelper.narrow(ohash);
      UserContextData.test(); 
      /* add SaveContext */
      osc = uc.addNewModule("SaveContext");
      SaveContextIOR = orb.object_to_string(osc);
      saveContext = SaveContextHelper.narrow(osc);
      saveContext.test(); 
      /* add GaussianScript */
      og = uc.addNewModule("gScript");
      gScriptIOR = orb.object_to_string(og);
      gscript = gScriptHelper.narrow(og);
      gscript.test(); 
      /* add submitJob */
      os = uc.addNewModule("submitJob");
      submitJobIOR = orb.object_to_string(os);
      submit = submitJobHelper.narrow(os);
      submit.test(); 
      /* add remotefile */
      orf = uc.addNewModule("RemoteFile");
      RemoteFileIOR = orb.object_to_string(orf);
      remotefile = RemoteFileHelper.narrow(orf);
      remotefile.test(); 
      /* add FileBrowser */
      ofb = uc.addNewModule("FileBrowser");
      RemoteFileIOR = orb.object_to_string(ofb);
      filebrowser = FileBrowserHelper.narrow(ofb);
      filebrowser.test();

      System.out.println("All the modules successfuly created");
      
      String udir=DDir+"USER/"+UserName;
      setContextData(uc,"Directory",udir);

      nv = new navigator(this,UserName);
      nv.setSize(400,150);

      System.out.println("navigator created"); 
      ac=getAppletContext();

      java.awt.Container c = getContentPane();
      getContentPane().setLayout(new BorderLayout());

      JPanel upperPanel = new JPanel();
      upperPanel.setLayout(new BorderLayout());

      JPanel bP = new JPanel();
      bP.setLayout(new GridLayout(2,2));
      JButton b1 = new JButton("Home");
      JButton b2 = new JButton("Navigator");
      JButton b3 = new JButton("Logout");
      JButton b4 = new JButton("About");

      bP.add(b1);
      bP.add(b2);
      bP.add(b3);
      bP.add(b4);

      hostLabel= new JTextField(hostname,25);
      hostLabel.setEditable(false);

      contextLabel= new JTextField(25);
      setContextLabel(uc.getObjectID());
      contextLabel.setEditable(false);

      cP = new JPanel();
      cP.setLayout(card);

      System.out.println("create TabbedPane...");
      cards = new TabbedPane[n];

      System.out.println("TabbedPane created");

      for(int i=0; i<n; i++) { 
         cards[i]=null;
      } 

       System.out.println("adding card for " + rootname);
      addCard(rootname);      
       System.out.println("show card"); 
      showCard(rootname);

       System.out.println("make action listener");

      ActionListener Blistener = new ActionListener() {
      public void actionPerformed(ActionEvent e) {
          String what= e.getActionCommand().toString();
          if(what.equals("Navigator")) {
          nv.show();           
	  }
	  if(what.equals("Logout")) {
	    try {
              uc.removeMyself();
	    }
            catch(org.omg.CORBA.COMM_FAILURE exception) {
             System.out.println("user context deleted");
            pageurl="http://heechee.osc.edu:8002/servlet/Portal";
            try {
            docURL = new URL(pageurl);
            ac.showDocument(docURL);
            } catch (Exception ee) {System.out.println("Really? "+e);}
	    }
	  }
          if(what.equals("Home"))  {
               pageurl="http://osprey4.npac.syr.edu:8001/servlets/UserPage?userContext="+UserName;
          try { 
              docURL=new URL(pageurl);
              showPage(docURL);
            } catch (Exception mo) {System.out.println(mo);}
	  }
	  if(what.equals("About")) {
            pageurl="http://www.npac.syr.edu/users/haupt/WebFlow/";
            try { 
              docURL=new URL(pageurl);
              showPage(docURL);
            } catch (MalformedURLException me) {System.out.println(me);}

	  }
      }
      };

       System.out.println("add action listener");
      b1.addActionListener(Blistener);
      b2.addActionListener(Blistener);
      b3.addActionListener(Blistener);
      b4.addActionListener(Blistener);

        System.out.println("add panels");

      upperPanel.add(BorderLayout.CENTER,bP);
      JPanel labPanel = new JPanel();
      labPanel.setLayout(new GridLayout(2,1)); 
      labPanel.add(hostLabel);
      labPanel.add(contextLabel);
      upperPanel.add(BorderLayout.SOUTH,labPanel);
      c.add(BorderLayout.NORTH,upperPanel);
      c.add(BorderLayout.CENTER,cP);


      System.out.println("restore job Vectors");
      //restore job Vectors
      userDir = getContextData(uc,"Directory");
      String[] a = saveContext.deserializeArray(userDir+"/jobVector"); 
      String[] b = saveContext.deserializeArray(userDir+"/jobContexts");
      if(!a[0].equals("none")) {
          for(int i=0;i<a.length;i++) {  
             jobVector.addElement(a[i]);    
             jobContexts.addElement(b[i]);

             if(a[i].indexOf("running")>0) { 
                 String jobid = a[i].substring(0,a[i].indexOf("running")-1);
                 System.out.println(jobid+"XXX");  
                 WebFlowContext aplc = WebFlowContextHelper.narrow(
                                       uc.getContext(b[i]));   
                 String destDir=getContextData(aplc,"Directory");  
                 String inFile=getContextData(aplc,"inFile");
                 String outFile=getContextData(aplc,"outFile");
                 String dest=getContextData(aplc,"dest");
                 String jobName=getContextData(aplc,"jobName");
                 String aMachine=getContextData(aplc,"machine"); 
                 if(jobName==null || jobName.length()<1) jobName=jobid; 
                 System.out.println("jobName="+jobName); 
                 System.out.println("machine="+aMachine); 
                 monitorJob mj = new monitorJob(this, jobid, cards[rootCard], 
                             outFile, dest, submit, i, destDir,
                             aMachine,inFile,jobName);
                 Thread mt = new Thread(mj);
                 mt.start(); 
	     }
	  }
          cards[rootCard].JobStatus.refreshJobPanel(jobVector);
          cards[rootCard].showJobTab();
      }

      System.out.println("init completed");

      }
 


     public void showCard(String what){
      card.show(cP,what);
     }

// added by jkl
// Takes a string, skips the chars and returns truncated string

    public String skipChars(String inpString, String charsToSkip) {

       int len = inpString.length();
       int ch;
       StringBuffer buff = new StringBuffer(len);
       for (int i = 0; i < len; i++) {
         ch = inpString.charAt(i);
         if(charsToSkip.indexOf(ch) == -1) {
        	buff.append((char)ch);
        	}
            }
       return buff.toString();
       }



     public void addCard(String host){
	 try {
	     int idx=getHostIndex(host);
	     System.out.println("Adding card for host: " + host + ", card number is " + idx);
	     cards[idx] = new TabbedPane(this,UserName,fileRoot[idx],hostnames[idx]);
	     cP.add(hostnames[idx],cards[idx]);
	 } catch (Exception e) {
	     System.out.println(e+" while creating TabbedPane");
         }
     }

       public ORB getORB() {
         return orb;
       }


     public String getUserName() {
       return UserName;

     }
     public void setUserName(String UC) {
       UserName=UC;
     }

    public void showPage(URL docURL) {
    ac.showDocument(docURL,"GatewayHTML");
   }

     public void showNavigator(){
      nv.show();
	}

     public void setHostname(String host) {
       hostname = host;
       hostLabel.setText(host);
     }

     public String getHostname() {
       return hostname;
     }  

     public void setRootname(String host) {
       rootname = host;
     }

     public String getRootname() {
       return rootname;
     }  

     public void setConnectedHost(String host) {
       for (int i=0; i<n; i++) {
         if(hostnames[i].equals(host)) connectedHosts[i]=true;
       }
     }
    
    public WebFlowContext getUserContext() {
       return uc;
     }

     public void setSlaves(String host, WebFlowContext wc){
       Slaves.put(host,wc);
     }

     public WebFlowContext getSlaves(String host){
       WebFlowContext wc=(WebFlowContext)Slaves.get(host);
      return wc;
     }

       public int getHostIndex(String host){
	   System.out.println("host = " + host);
	   System.out.println(ht.get(host));
	   int idx = ((Integer)ht.get(host)).intValue();
	   System.out.println("idx = " + idx);
	   return idx;
       }

	//kenf insert - startPD
     public void startPD(String contextName) {
       System.out.println("startPD: " + contextName);
       if(contextName.equals("New")) {
          pageurl=ccm101.test2();
          System.out.println(pageurl);
          callServlet(ServletDir+pageurl);
          // listContexts(uc,".PC", "project");
       }
       if(contextName.equals("Session")) {
           if(currentProject()) {
             listContexts(ProjectContext,".SC", "session");
           }
           else {
            callServlet(pageurl);
           }
       }
       if(contextName.equals("Application")) {
           if(currentProject()) {
               if(currentSession()) {
                 listContexts(SessionContext,".AC", "application");
               }
               else {
                 callServlet(pageurl);
               }
           }
           else {
            callServlet(pageurl);
           }
       }
     }
	//kenf - end startPD

     public void selectContexts(String contextName) {
       System.out.println("selectContexts: "+contextName); 
       if(contextName.equals("Project")) {
          listContexts(uc,".PC", "project");
       }
       if(contextName.equals("Session")) {
          listContexts(ProjectContext,".SC", "session");
       } 
       if(contextName.equals("Application")) {
          listContexts(SessionContext,".AC", "application");
       } 
     }

     public void selectContexts2(String contextName) {
       System.out.println("selectContexts2: "+contextName); 
       if(contextName.equals("Project")) {
          listContexts2(uc,".PC", "project");
       }
       if(contextName.equals("Session")) {
          listContexts2(ProjectContext,".SC", "session");
       } 
       if(contextName.equals("Application")) {
          listContexts2(SessionContext,".AC", "application");
       } 
     }

     public void listContexts(WebFlowContext root, String suffix,
                              String name) {
       Vector ContextList = makeListOfContexts(root,suffix);     
       Enumeration l = ContextList.elements();
       int numberOfElements = ContextList.size();

       pageurl = ServletDir;
       int k=0;

       System.out.println(suffix);

       if(suffix.equals(".SC")) {
          ProjectName = ProjectContextData.getParam("Project");
       }
       if(suffix.equals(".AC")) {
          ProjectName = SessionContextData.getParam("Project");
          SessionName = SessionContextData.getParam("Session");
       }

       System.out.println(numberOfElements);
       if(numberOfElements>0) {
	 if(suffix.equals(".AC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&Session="+SessionName;
             pageurl += "&n="+numberOfElements;
	 }
         else {
	   if(suffix.equals(".SC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&n="+numberOfElements;
	   }
           else {  
             pageurl = ServletDir+"PSE"+name+"list";
             pageurl += "?n="+numberOfElements;
	   }
	 }

          while (l.hasMoreElements()){
           k++;
           WebFlowContext c = (WebFlowContext)l.nextElement();
           pageurl += "&c"+k+"="+c.getObjectID();
           System.out.println(pageurl); 
           if(suffix.equals(".SC")) {
             ContextData cd = findContextData(c);
             pageurl += "&s"+k+"="+cd.getParam("Time");
             pageurl += "&q"+k+"="+cd.getParam("LastTime");
	   }
	  }
       }

       else {

	 if(suffix.equals(".AC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&Session="+SessionName;
             pageurl += "&n=0";
	 }
         else {
	   if(suffix.equals(".SC")) {
               pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
               pageurl += "&n=0";
	   }
           else {  
               pageurl = ServletDir+"PSE"+name+"list";
               pageurl += "?n=0";
	   }
	 }
       }
       System.out.println("listContexts: "+pageurl);
       callServlet(pageurl);
     }

     public void listContexts2(WebFlowContext root, String suffix,
                              String name) {
	System.out.println("in listContexts2");
       Vector ContextList = makeListOfContexts(root,suffix);     
       Enumeration l = ContextList.elements();
       int numberOfElements = ContextList.size();

       pageurl = ServletDir;
       int k=0;

       System.out.println(suffix);

       if(suffix.equals(".SC")) {
          ProjectName = ProjectContextData.getParam("Project");
       }
       if(suffix.equals(".AC")) {
          ProjectName = SessionContextData.getParam("Project");
          SessionName = SessionContextData.getParam("Session");
       }

       System.out.println(numberOfElements);
       if(numberOfElements>0) {
	 if(suffix.equals(".AC")) {
             pageurl = ServletDir+"PSEprojectListPD?Project="+ProjectName;
             pageurl += "&Session="+SessionName;
             pageurl += "&n="+numberOfElements;
	 }
         else {
	   if(suffix.equals(".SC")) {
             pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
             pageurl += "&n="+numberOfElements;
	   }
           else {  
             pageurl = ServletDir+"PSEprojectListPD";
             pageurl += "?n="+numberOfElements;
	   }
	 }

          while (l.hasMoreElements()){
           k++;
           WebFlowContext c = (WebFlowContext)l.nextElement();
           pageurl += "&c"+k+"="+c.getObjectID();
           System.out.println("in while loop listContexts2  " + pageurl); 
           if(suffix.equals(".SC")) {
             ContextData cd = findContextData(c);
             pageurl += "&s"+k+"="+cd.getParam("Time");
             pageurl += "&q"+k+"="+cd.getParam("LastTime");
	   }
	  }
       }

       else {

	 if(suffix.equals(".AC")) {
             pageurl = ServletDir+"PSEprojectListPD?Project="+ProjectName;
             pageurl += "&Session="+SessionName;
             pageurl += "&n=0";
	 }
         else {
	   if(suffix.equals(".SC")) {
               pageurl = ServletDir+"PSE"+name+"list?Project="+ProjectName;
               pageurl += "&n=0";
	   }
           else {  
               pageurl = ServletDir+"PSE"+name+"list";
               pageurl += "?n=0";
	   }
	 }
       }
       System.out.println("listContexts2: "+pageurl);
       callServlet(pageurl);
     }

     /* there is ContextManager method that returns Array of those */
     public Vector makeListOfContexts(WebFlowContext root, String suffix) {
       // all contexts are returned, possibly of different kind!
      if(debug) System.out.println("suffix="+suffix);
      Vector list = new Vector();
      org.omg.CORBA.Object[] ContextObjs=root.toArray();
// if(debug) System.out.println("number of objects === "+ContextObjs.length);
      for(int i=0; i<ContextObjs.length;i++) {
         WebFlow.BeanContextChild Something=null;
         Something=BeanContextChildHelper.narrow(ContextObjs[i]);
         String ObjectName=Something.getObjectID();
//System.out.println("Name: "+ObjectName);
         if(ObjectName.endsWith(suffix)) {
           WebFlowContext c = WebFlowContextHelper.narrow(ContextObjs[i]);
           list.addElement(c);
	 }
      } 
      return list; 
     }

     public String[] makeTSortedList(WebFlowContext root) {
         Vector AllContexts = new Vector();
         Vector Times = new Vector(); 
         Vector PContexts = makeListOfContexts(root,".PC");
         Enumeration PCenum = PContexts.elements();
         while(PCenum.hasMoreElements()) {
            WebFlowContext wfc = (WebFlowContext)PCenum.nextElement();
            Vector SContexts = makeListOfContexts(wfc,".SC"); 
            int n = SContexts.size();
            for(int i=0; i<n; i++) {
              WebFlowContext wfc1 = (WebFlowContext)SContexts.elementAt(i);
              String key = wfc1.getObjectID()+"/ContextData";
              org.omg.CORBA.Object cobj = uc.getKeyedChild(key); 
              ContextData cd=null; 
              if(cobj != null){
                 cd = ContextDataHelper.narrow(cobj); 
	      }
              else {
              System.out.println("contextData not found!");
	      }
	    Times.addElement(cd.getParam("Time"));
            AllContexts.addElement(cd.getParam("Session"));
	    }
	 }
        String[] result = Tsort(AllContexts,Times);
        return result;    
     }

     public String[] Tsort(Vector values, Vector keys){
        int n = values.size();
        String[] result = new String[n];
        long[] time = new long[n];
        for(int i=0;i<n;i++) { result[i] = (String)values.elementAt(i);}
        for(int i=0;i<n;i++) { 
              time[i] = ((Long)values.elementAt(i)).longValue();
	}
        for(int i=n-1;i>-1;i--){
	  for(int j=0;j<i;j++) {
            if(time[j]>time[j+1]) {
               long A = time[j];
               String B = result[j];
               time[j]=time[j+1];
               result[j]=result[j+1];
               time[j+1]=A;
               result[j+1]=B;
	    }
	  }
	}
        return result;
     }

     public void setFormLength() {
      System.out.println("setFormLength: parameter needed!");
     }

     public void setFormLength(String nstring) {
      System.out.println("start setFormLength");
     int n=0;
       try {
         n=Integer.parseInt(nstring); 
	   }
       catch (Exception e) { System.out.println(e);} 
      FormLength = n;
      FormElementNames = new String[n];  
      FormElementValues = new String[n];
      System.out.println("(String) new form of length "+n);
     }

     public void addFormElement(int i, String name, String value) {
       FormElementNames[i]=name;
       FormElementValues[i]=value;
       System.out.println("add element: "+name+" = "+value);

       if(value.equals("true")) {
          value=name;
          name="selectedItem";
       }


       if(value.indexOf("_false")<0) {
           int idx = value.indexOf("_true"); 
	   if(idx>-1) {
              value=value.substring(0,idx);
	   }
           HTMLform.put(name,value);
       }
       if(name.equals("page")) {
	 try {
            currentPage = Integer.parseInt(value);
	 }
	 catch (NumberFormatException nfe) {System.out.println(nfe);}
       }
	//kenf - insert subpage hidden input here
        if(name.equals("subpage")){
                subpage = value;
                System.out.println("HTMLform equals subpage" + subpage);
        }
	//kenf - end subpage
     }


     public void forwardLink() {
      System.out.println("forwardLink called");
     }

     public void forwardLink(String page) {
      int i=0; 
	subpage = ""; //kenf - set subpage to empty string
       try {
         i = Integer.parseInt(page);
       } catch (Exception e) {System.out.println(e);} 
      currentPage = i;
      FormLength=0;
      System.out.println("?? process page "+currentPage); 
      forwardForm();
     }

     public void forwardForm() {
      System.out.println("forwardForm: #params = "+FormLength);
      
      for (int i=0; i<FormLength; i++) {
          System.out.println(FormElementNames[i]+" = "+FormElementValues[i]);
      }
	//kenf - test subpage value
        System.out.println("in forwardForm subpage = "+ subpage);
        System.out.println("in forwardForm currentpage = "+ currentPage);
	//kenf - end of subpage test

      
      switch(currentPage) {

      case 0:	//kenf - modify to start the PD
	//kenf - redraw the navigator and html frames
        // you came from Problem description button from main ccmNavigator 
        // load the probDesc.java servlet to start the new problem form set
        if(subpage == null){
                subpage="";
                System.out.println("setting subpage to empty");
        }
        pageurl = PSEdir + "pdNavigator.html";
	System.out.println("in case 0 first pageurl = " + pageurl);
        callServlet2(pageurl, "navigator");
/*
        pageurl=PSEdir+"probDescEntry.html";
        callServlet(pageurl);
*/
	System.out.println("Calling selectContexts2");
	selectContexts2("Project");
        break;
	//kenf - end of redraw the navigator and html frames

      case 1:
	/*
	{
          if(FormLength>0) createNewProject();
          else {
            if(currentProject()) { 
              pageurl = ServletDir+"PSEnewSession?Project="+ProjectName;
	    }
            callServlet(pageurl); 
	  }
          break;
	}
	*/
	//kenf - the CT entry
        {
        // Next step in the problem description form set
        // Get the title of the probDesc and create a new project context
	//Tom        if(FormLength > 0) createNewProject();
        if(FormLength > 0) ReplaceProject();
        else {
            if(currentProject()) {
                // set new CT link for this probDesc.
                pageurl = ServletDir+"PSEnewSession?Project="+ProjectName;
            }
            callServlet(pageurl);
        }
        break;
        }
	//kenf - end of CT entry

      case 11:
	{
          //you came from PSEnewSession servlet
	  // adds a new session to the ProjectContext  
          if(debug) System.out.println("start processing page 11");

          if(FormLength>0) createNewSession();
          else {
     
          // you continue or came here from Select Session button 
          // now prepare for the next form
          // call servlet that asks for application(s)
          // servlet name is PSEaddApplication 
          // parameters: ProjectName, SessionName
          // eventually it will be replaced by PSE

          if(currentProject()) {
             System.out.println("currentProject OK");
	    if(currentSession()) {
             System.out.println("currentSession OK");
              if(sessionOfProject()) {
             System.out.println("sessionOfProject OK");
                  ProjectName=SessionContextData.getParam("Project");
                  SessionName=SessionContextData.getParam("Session"); 
	      //pageurl=ServletDir+"PSEapplicationlist?Project="+ProjectName;
	      //pageurl+="&Session="+SessionName;
             listContexts(SessionContext,".AC", "application");
             System.out.println("11 OK");

	      }
	    }
	  }
	  //callServlet(pageurl); 
	  }
         break; 
	}

      case 2:    
	{
	  // adds an new application context to the session context
          // returns select input page        

	 if(FormLength>0) createNewApplication();
         else {
         if(currentProject()) {
           if(currentSession()) {
	     if(sessionOfProject()) {
               if(currentApplication()) {
                 ProjectName=ApplicationContextData.getParam("Project");
                 SessionName=ApplicationContextData.getParam("Session"); 
                 ApplicationName = ApplicationContextData.getParam("ApplicationName");
                 pageurl=ServletDir+"PSEinput?appl="+ApplicationName;
                 pageurl+="&Project="+ProjectName; 
                 pageurl+="&Session="+SessionName;
	       } 
	     }
	   }
	 }
	 }
         callServlet(pageurl);
         break;
	}             
      case 12:
	{
          // process select host page
          // returns select job page

         String userDir = DDir+UserName+"/";
         inputFile = "";

         String machine="";
	 if(FormLength>0) {
           machine =  (String)HTMLform.get("target");
           ApplicationContextData.setParam("target",machine);
	 }
	  else {
           if(ApplicationContextData.containsKey("target")) {
                machine = ApplicationContextData.getParam("target");
                System.out.println(machine);
	   }
	   else {
                System.out.println("Case 12: no target key");
                machine = "";
	   }
	  }

         if(ApplicationContextData.containsKey("Code")) {
           ApplicationName=ApplicationContextData.getParam("Code");
	 }
         else System.out.println("Case 12: no Code Key"); 


         if(ApplicationContextData.containsKey("InputFile")) {
           inputFile=ApplicationContextData.getParam("InputFile");
	 }
         else System.out.println("Case 12: no inputFile Key"); 

         if(ApplicationContextData.containsKey("ApplDesc")) {
                 ApplicationName = ApplicationContextData.getParam("ApplDesc");
         }
         else { 
                 ApplicationName="";
                 System.out.println("Case 12: no ApplDesc key");
	 }
               
	 // decide where to write the actual application descriptor


	 // invent filename for Abstract Task Descriptor
         // later on put it to /UserName/ProjectName/SessionName.txt  
          String ATDpath=DDir+"USER/"+UserName+"/"; 
          String ADTfile = ATDpath+"whatever.txt";


         if(ApplicationName.length()>0) {
            if(machine.length()>0) { 
              pageurl = ServletDir+"PSEaTask?appl="+ApplicationName;
              pageurl += "&target="+machine;
              pageurl += "&inputFile="+inputFile;
              //pageurl += "&userDir="+userDir;
	      //  pageurl += "&xmlIOR="+XmlServerIOR;
              pageurl += "&Project="+ProjectName;  
              pageurl += "&Session="+SessionName;
              pageurl += "&File="+ADTfile;   
	    }
            else {
              pageurl = ServletDir+"PSEinputError?appl="+ApplicationName;
	    }
	 }
         else {
              pageurl = ServletDir+"PSEcodeError";
	 } 

         callServlet(pageurl);
         break; 
	}          

      case 3:
	{
          // process select input
          // returns submit job page

       if(FormLength >0) {
         inputFile = (String)HTMLform.get("InputFile");
         setContextData(ApplContext,"InputFile",inputFile); 
       }
       else { 
         appl= getContextData(ApplContext,"ApplDesc");
         ProjectName = getContextData(ApplContext,"Project");
         SessionName = getContextData(ApplContext,"Session");
         inputFile   = getContextData(ApplContext,"InputFile"); 
       }
	 /*  
         if(ApplicationContextData.containsKey("ApplDesc")) {
            appl=ApplicationContextData.getParam("ApplDesc");
	 }
         else System.out.println("Case 3: no ApplDesc Key"); 
         
         if(ApplicationContextData.containsKey("Project")) {
           ProjectName=ApplicationContextData.getParam("Project");
	 }
         else System.out.println("Case 3: no Project Key"); 

         if(ApplicationContextData.containsKey("Session")) {
           SessionName=ApplicationContextData.getParam("Session");
	 }
         else System.out.println("Case 3: no Session Key"); 

         if(ApplicationContextData.containsKey("InputFile")) {
           inputFile=ApplicationContextData.getParam("InputFile");
	 }
         else System.out.println("Case 3: no inputFile Key"); 
	 */

         pageurl= ServletDir+"PSEcode?appl="+appl+"&xmlIOR="+XmlServerIOR;
         pageurl += "&Project="+ProjectName;
         pageurl += "&Session="+SessionName;
         pageurl += "&inputFile="+inputFile;
         callServlet(pageurl);
         break;
	}          
      case 4:
	{
	  // you came from aTask
          // that servlet does not produce any data
          // it writes ATD
          // take everything from Application and Session ContextData
          // submit

          //process ATD 
          // to be done by ATDprocessor module to be written by Wendy
          // at this time we know that the selected application is 
          // to ne executed

          //ATD is supposed to have a pointer to the actual application
          //descriptor (AD). Filtering module is to be written by Rajshree.

          //So for the time being I assume that for each target I have my
	  //my AD. It is called ApplicationName-host. 

	  //Until the module is available, I allow one input
          //and one output file.

          //String target = ApplicationContextData.getParam("target");
          String target = getContextData(ApplContext,"target");
          String Application = getContextData(ApplContext,"Application");
          String ADpath=DDir+"USER/"+UserName+"/"; 
          String ADfile = ADpath+ApplicationName+"-"+target+".xml";
          System.out.println(ADfile); 

          if(parser.instantiateParser(ADfile)) { 
	    // src=parser.getSource();
            //dst=parser.getInFile();
            //transferFile(src,dest); 
	      
	      /*
		Commented by Alexey. Failed to compile 10/25/99 at 16:33
		parser.getCmdLine(target,"local");
	      */
            //src=parser.getOutFile();
            //dest=parser.getDest();              
            //transferFile(src,dest);
            pageurl=ServletDir+"Success";
	  }
          else {
            pageurl=ServletDir+"Error?what=submit+job+failed&where=case+4";
	  }  
 
          callServlet(pageurl);
          break;
	}
	case 21: 
	  {
            // you came from PSEprojectlist (select Project button)

           String action = (String)HTMLform.get("action"); 

            if(action.equals("new")) {
	         //ask the user for the name of the new project first
                 pageurl=ServletDir+"PSEnewProject";
                 setContextLabel(uc.getObjectID());
                 callServlet(pageurl);
	    }
            if(action.equals("delete")) {
                 String context = (String)HTMLform.get("ProjectContextName");
                 HTMLform.put("contextName",context);
                 ProjectContext = selectContext(uc,".PC","projectlist");
                 curDir=getContextData(ProjectContext,"Directory");
                 deleteProjectJobs(ProjectContext);
                 String cName=getContextData(ProjectContext,"Project");
                 System.out.println("Project to delete: "+cName); 
                 rmChild(uc,cName+".PC");
                 if(remotefile.rmdir(curDir))
                   System.out.println("project deleted");
                 else {
                   System.out.println("deletion failed!");
		 } 
                 ProjectContext.removeMyself();
                 setContextLabel(uc.getObjectID());
                 listContexts2(uc,".PC", "project");
	    } 
            if(action.equals("archive")) archiveProject();
            if(action.equals("select")) {
                 String context = (String)HTMLform.get("ProjectContextName");
                 HTMLform.put("contextName",context);
                 ProjectContext = selectContext(uc,".PC","projectlist");
                 ProjectContextData = findContextData(ProjectContext); 
                 // set global variables 
                 ProjectName = ProjectContextData.getParam("Project"); 
                 UserContextData.setParam("Project",ProjectName); 
                 setContextLabel(ProjectContext.getObjectID());
                 // list sessions added to the project
                 //listContexts(ProjectContext,".SC", "session");
                 // no: go to Problem Review Page - the servlet probDescPage 
     			String ttrf =  getContextData(ProjectContext,"Directory");            	
			System.out.println("in select project ProjectName = " + ttrf);
                        pageurl = ServletDir+"probDescPage2?Project="+ttrf;
                        callServlet(pageurl);
	    }

	   break; 
	  }  
	case 22: 
	  {
            // you came from PSEsessionlist (select Session button)

           String action = (String)HTMLform.get("action"); 

            if(action.equals("new")) {
		//warning: this is the same as case 23: modify both or none
	    if(ProjectContext != null) { 
		pageurl = PSEdir + "ctPNavigator.html";          
                callServlet2(pageurl, "navigator");
                pageurl=PSEdir+"ctSelectCode.html";
                callServlet(pageurl);
	    }
            else {
                selectContexts("Project"); 
	    }

	    }
            if(action.equals("delete")) {  
               String context = (String)HTMLform.get("SessionContextName");
               System.out.println("selectedItem="+context);
               HTMLform.put("contextName",context);
               SessionContext = selectContext(ProjectContext,".SC",
                                               "sessionlist");
               curDir=getContextData(SessionContext,"Directory");
               remotefile.rmdir(curDir);
               deleteProjectJobs(SessionContext);
               String cName=getContextData(SessionContext,"Session");
               rmChild(ProjectContext,cName+".SC"); 
               SessionContext.removeMyself();
               listContexts(ProjectContext,".SC", "session");
	    }
            if(action.equals("archive")) archiveSession();
            if(action.equals("select")) {
                 //find session context
               String context = (String)HTMLform.get("SessionContextName");
               HTMLform.put("contextName",context);
               System.out.println("selectContext: "+context); 
               SessionContext = selectContext(ProjectContext,".SC",
                                               "sessionlist");
               System.out.println("back from select context");
               SessionContextData = findContextData(SessionContext); 
	         //find application context 
               String aplcName="";
               if(SessionContextData.containsKey("Children")) {
                    aplcName=SessionContextData.getParam("Children");
                    WebFlowContext aplc = WebFlowContextHelper.narrow(
                                          uc.getContext(aplcName));
                    String currDir=getContextData(aplc,"Directory");
                    String selectedFile = currDir+"/input.txt"; 
                    String ApplicationName=getContextData(aplc,"Application");

                    if(ApplicationName.equals("gamess")) { 
                    pageurl=ServletDir+"jklGamessSubmit?";
	            }
                    else {
                        pageurl=ServletDir+"jklGaussSubmit?";
               	    }
                    pageurl += "UserContext="+UserName;
                    pageurl += "&Application="+ApplicationName;     
                    pageurl += "&inputFile="+selectedFile;   
              
                    callServlet(pageurl);                        
               }
	       else {
		   //there is no application context
                    if(ProjectContext != null) { 
		        pageurl = PSEdir + "ctPNavigator.html";          
                        callServlet2(pageurl, "navigator");
                        pageurl=PSEdir+"ctSelectCode.html";
                        callServlet(pageurl);
		    }
                    else {
                        selectContexts("Project"); 
	            }
	       }
	    }

	   break; 
	  }  

      case 23:
		//warning: this is the same as case 22/new: modify both or none
	  {
	    if(ProjectContext != null) { 
		pageurl = PSEdir + "ctPNavigator.html";          
                callServlet2(pageurl, "navigator");
                pageurl=PSEdir+"ctSelectCode.html";
                callServlet(pageurl);
	    }
            else {
                selectContexts("Project"); 
	    }
          break;
	  }      

      case 24:
	  {
	    if(ProjectContext != null) { 
                ApplicationName = (String)HTMLform.get("Application");
                if(ApplicationName.equals("gamess")) {
		    pageurl=PSEdir+"ctSelectInpGamess.html";
		    System.out.println("ApplicationGM: "+ApplicationName);  
		}
		else {
		    pageurl=PSEdir+"ctSelectInp.html";
		    System.out.println("ApplicationGU: "+ApplicationName);  
		}

                callServlet(pageurl);
	    }
            else {
                selectContexts("Project"); 
	    }          break;
	  }      

      case 27:
	  {
          ApplicationName = (String)HTMLform.get("Application");
          fName=(String)HTMLform.get("fName"); 
          System.out.println("input type: "+fName);  
          if(fName.equals("upload")) {
              selectedFile="DESCRIPTORS/USER/"+UserName+"/uploaded.txt";
	  }
          if(fName.equals("default")) {
              selectedFile="PSE/Templates/templateInput.txt";
	  }
          if(fName.equals("userSelect")) {
              selectedFile=cards[rootCard].FileBrowser.getCurrentFile();
              System.out.println("selectedFile = "+selectedFile);  
	  }
          if(selectedFile==null) 
	      selectedFile="PSE/Templates/templateInput.txt";

          if(ApplicationName.equals("gamess")) { 
              pageurl=ServletDir+"jklGamessSubmit?";
	      selectedFile="";
	  }
          else if(ApplicationName.equals("gaussian")) {
              pageurl=ServletDir+"jklGaussSubmit?";
	      selectedFile="";
	  }
          pageurl += "UserContext="+UserName;
          pageurl += "&Application="+ApplicationName;
          if(!selectedFile.equals("")) {
            pageurl += "&inputFile="+selectedFile;
	  }
          callServlet(pageurl);
          break;
	  }      

      case 50:
	{
	  // get information about application to be submitted
	  if(FormLength >0 ) {
           String commandLine=(String)HTMLform.get("commandLine");
           String inFile=(String)HTMLform.get("inFile");
           String source=(String)HTMLform.get("source"); 
           String outFile=(String)HTMLform.get("outFile");
           String dest=(String)HTMLform.get("dest"); 
           String scriptSource=(String)HTMLform.get("scriptSource");
           String scriptDest=(String)HTMLform.get("scriptDest");
           /* what should be done now:
            1.  rcp scriptSource to scriptDest
            2.  rcp source to inFile
            3.  rsh commandLine
            4.  wait till completed
            5.  rcp outFile to 
	    */   
	  }
         break;
	} 
	//kenf - the toolkit pages - 101, 102, 103, 104, 105, 1000
        case 51:
            {
           pageurl="http://heechee.osc.edu:8002/cgi-bin/s1";
           callServlet(pageurl);
           break;
            }

        //kenf - PD Toolkit pages
      case 101:
          {
                	// you came from Problem Description button
                System.out.println("process 101");
                System.out.println(" in 101 subpage = " + subpage);
                if(subpage.equals("")){
                        pageurl = PSEdir + "pdNavigator.html";
                        callServlet2(pageurl, "navigator");
                        pageurl=PSEdir+"probDescEntry.html";
                        callServlet(pageurl);
                } else if(subpage.equals("Entry")){
                        	// First step in the problem description form set
                        System.out.println("In 101 Entry");
                        pageurl = ServletDir + "PSEnewProject";
                        System.out.println("pageurl = " + pageurl);
                        callServlet(pageurl);
                } else if(subpage.equals("Create")){
                  // Next step in the problem description form set
                  // Get the title of the probDesc and create a new project context
                        System.out.println("In 101 Create");
                        pageurl = PSEdir + "pdCreate.html";
                        System.out.println("pageurl = " + pageurl);
                        callServlet(pageurl);
                } else if(subpage.equals("New")){
                        // Next step in the problem description form set
                        // Get the title of the probDesc and create a new 
		        // project context
                        System.out.println("In 101 New");
                        if(FormLength > 0) {
                          System.out.println("FormLength > 0");
			  createNewProject();
                          setContextLabel(ProjectContext.getObjectID()); 
			  //ReplaceProject();
                          if(currentProject()) {
                          pageurl = PSEdir + "pg1.html";
                          callServlet(pageurl);
			  }
                        }
                } else if(subpage.equals("A")){
                        System.out.println("Here in A");
                        for (int i = 0; i < FormLength; i++) {
                                System.out.println(" in subpage A" +
                                        FormElementNames[i]+" = "+FormElementValues[i]);
			    	System.out.println("ProjectContext in 101A = " + ProjectContext);
				if(FormElementValues[i].indexOf("_true") != -1){
                                        String v = FormElementValues[i].substring(0, FormElementValues[i].indexOf("_true"));
                                        System.out.println("calling setContextData " + ProjectContext + "\tSystem" + "\t" + v);
					setContextData(ProjectContext, "System", v);
                                }
                        }
                        pageurl = PSEdir + "pg2.html";
                        callServlet(pageurl);
                } else if(subpage.equals("B")){
                        System.out.println("Here in B");
                        for (int i = 0; i < FormLength; i++) {
                                System.out.println(" in subpage B\t" +
                                        FormElementNames[i]+" = "+FormElementValues[i]);
				if(FormElementNames[i].equals("macrp")){
                                	String v = FormElementValues[i];
                                	System.out.println("calling setContextData " + ProjectContext + "\tProperties" + "\t" + v);
					//Tom added:
                                        v=v.substring(2);         
					setContextData(ProjectContext, "Properties", v);
				}
                        }
                        pageurl = PSEdir + "pg3.html";
                        callServlet(pageurl);
                } else if(subpage.equals("C")){
                        System.out.println("Here in C");
                        for (int i = 0; i < FormLength; i++) {
                                System.out.println(" in subpage C" +
                                        FormElementNames[i]+" = "+FormElementValues[i]);
				if(FormElementNames[i].equals("dprop")){
                                	String v = FormElementValues[i];
                                	System.out.println("calling setContextData " + ProjectContext + "\tdetailedProperties" + "\t" + v);
					//Tom added:
                                        v=v.substring(2);         
					setContextData(ProjectContext, "dProperties", v);
                                }
                        }
                        pageurl = PSEdir + "pg4.html";
                        callServlet(pageurl);
                } else if(subpage.equals("D")){
                        System.out.println("Here in D");
                        for (int i = 0; i < FormLength; i++) {
                                System.out.println(" in subpage D" +
                                        FormElementNames[i]+" = "+FormElementValues[i]);
  				System.out.println("ProjectContext in 101D = " + ProjectContext);
  				if(FormElementValues[i].indexOf("_true") != -1){
  					String v = FormElementValues[i].substring(0, FormElementValues[i].indexOf("_true"));
  					System.out.println("calling setContextData " + ProjectContext + "\tSize" + "\t" + v);
  					setContextData(ProjectContext, "Size", v);
  				}
				/*
				if(FormElementNames[i].equals("size")){
                                	String v = FormElementValues[i];
                                	System.out.println("calling setContextData " + ProjectContext + "\tsize" + "\t" + v);
					//Tom added:
                                        v=v.substring(2);         
					setContextData(ProjectContext, "size", v);
                                }
				*/
                        }
                        pageurl = PSEdir + "pg5.html";
                        callServlet(pageurl);
                } else if(subpage.equals("E")){
                        System.out.println("Here in E");
                        for (int i = 0; i < FormLength; i++) {
                                System.out.println(" in subpage E" +
                                        FormElementNames[i]+" = "+FormElementValues[i]);
  				System.out.println("ProjectContext in 101E = " + ProjectContext);
  				if(FormElementValues[i].indexOf("_true") != -1){
  					String v = FormElementValues[i].substring(0, FormElementValues[i].indexOf("_true"));
  					System.out.println("calling setContextData " + ProjectContext + "\tRigor" + "\t" + v);
  					setContextData(ProjectContext, "Rigor", v);
  				}
				/*
				if(FormElementNames[i].equals("rigor")){
                                	String v = FormElementValues[i];
                                	System.out.println("calling setContextData " + ProjectContext + "\tRigor" + "\t" + v);
					//Tom added:
                                        v=v.substring(2);         
					setContextData(ProjectContext, "Rigor", v);
                                }
				*/
                        }
			System.out.println("Returned from set Context");
     			String ttrf =  getContextData(ProjectContext,"Directory");            	
			System.out.println("subPage E:ProjectName = " + ttrf);
                        pageurl = ServletDir+"probDescPage2?Project="+ttrf;
                        callServlet(pageurl);
                }
                break;
          }


      case 301: 
	  {
           pageurl=ServletDir+"jklGaussSubmit?";
           pageurl += "UserContext=jkl&Application=gaussian";
           callServlet(pageurl);
           break;
	  }

        case 102:
          {
          // The Code layer. 
          if(subpage.equals("")){
	      if(ProjectContext != null) { 
		pageurl = PSEdir + "ctENavigator.html";
                callServlet2(pageurl, "navigator");
                pageurl=PSEdir+"ctEntry.html";
                callServlet(pageurl);
	      }
              else {
                selectContexts("Project"); 
	      }
		break;
	  }
          else if(subpage.equals("fromPD")){
		pageurl = PSEdir + "ctPNavigator.html";
                callServlet2(pageurl, "navigator");
                pageurl=PSEdir+"ctPEntry.html";
                callServlet(pageurl);
		break;
	  }

          else if(subpage.equals("B")){
		pageurl = PSEdir + "ccmNavigator.html";
                callServlet2(pageurl, "navigator");

            if(FormLength > 0) {
              	System.out.println("FormLength > 0");
                String jobName = (String)HTMLform.get("jobname");
                if(jobName==null || jobName.length()<1) {
                   jobName = "job";
                   Date d = new Date();
                   long num = d.getTime();
                   HTMLform.put("SessionContextName",Long.toString(num)); 
		}
                else {
                   HTMLform.put("SessionContextName",jobName); 
                   //because the jobName is also Session Name
		}
              	createNewSession();
         	createNewApplication();
                System.out.println("application created"); 
         	String application = (String)HTMLform.get("application");
         	String DirName = (String)HTMLform.get("dirname");
         	String remoteDir = (String)HTMLform.get("remoteDir");
         	String machine = (String)HTMLform.get("machine");
                System.out.println(application+" "+machine);
         	setContextData(ApplContext,"machine",machine);        

         	// take input file contents from the textarea and save on the server
         	DirName = "/home/webflow/Data/"+DirName;
         	System.out.println("DirName="+DirName);
         	setContextData(ApplContext,"DirName",DirName);

		// inputdata contains entry to the inputdata text area
         	String inputdata = (String)HTMLform.get("inputdata");

		// remove ^M and ^Z from the string (DOS stuff)
		inputdata = skipChars(inputdata, "\u000d\u001a"); 
		System.out.println(inputdata);

		// Input file may be something like gaussian.in or gamess.inp
         	String InputFile = DirName+"/"+application+".inp";

		// saves the contents of input text area in file InputFile
         	remotefile.saveAsFile(InputFile, inputdata);

//         	remotefile.saveAsFile(DirName+"/dos",inputdata);
//		copies the file dos --> gxxxx.inp and removes ^M characters 
//              submit.to_unix(DirName+"/dos",InputFile);

//         	submit.submitLocally("cp " + DirName + "/dos " + DirName +
//                 "/junk-jkl");

         	setContextData(ApplContext,"InputFile",InputFile);
	
         	//create a new directory on the target machine
         	//and put stuff there 
         	remoteDir = "/home/pse/pse/"+remoteDir;
         	setContextData(ApplContext,"remoteDir",remoteDir);
                String outFile = remoteDir+"/"+application+".OUT";
                String dest = DirName+"/"+application+".OUT";
         	submit.submitLocally("rsh -l pse "+machine+" mkdir "+remoteDir);
         	submit.exportFile(DirName+"/job.script", remoteDir + "/job.script", machine, "pse");

                String inFile = remoteDir+"/"+application + ".inp";
		submit.exportFile(InputFile, inFile, machine, "pse");

             System.out.println("submitNQS:"+remoteDir+"/job.script");
             String jobid = submit.submitNQS(remoteDir + "/job.script");
             jobVector.addElement(jobName+" running");
             String acname=ApplicationContextData.getParam("ApplicationName");
             System.out.println(acname);
             jobContexts.addElement(acname); 
             jobIndex = jobVector.indexOf(jobName+" running");
             System.out.println("jobIndex="+jobIndex);
             ApplicationContextData.setParam("dest",dest);
             ApplicationContextData.setParam("inFile",inFile);
             ApplicationContextData.setParam("outFile",outFile);
             ApplicationContextData.setParam("JobId",jobid);
             ApplicationContextData.setParam("JobName",jobName);

             cards[rootCard].JobStatus.refreshJobPanel(jobVector);
             cards[rootCard].showJobTab();
             String destDir = ApplicationContextData.getParam("Directory"); 
             monitorJob mj = new monitorJob(this, jobid, cards[rootCard], 
                             outFile, dest, submit, jobIndex, destDir,
                             machine,inFile,jobName);
             Thread mt = new Thread(mj);
             mt.start(); 
  
             long time = (new Date()).getTime();
             ApplicationContextData.setParam("startTime",Long.toString(time)); 
             pageurl = ServletDir + "JobSubmitted?";
             pageurl += "Application="+application;
             pageurl += "&JobId="+jobid;
             pageurl += "&time="+Long.toString(time);
             pageurl += "&Project="+ProjectName;   
             pageurl += "&Session="+SessionName;   
             pageurl += "&pContext="+ProjectContext.getObjectID();   
             pageurl += "&sContext="+SessionContext.getObjectID();   
             callServlet(pageurl);
              }
            }
          }
        case 103:
          {
                // you came from Analysis Toolkit button
		System.out.println("process 103");
		System.out.println(" in 103 subpage = " + subpage);
                if(subpage.equals("")) {
                  pageurl = PSEdir + "atNavigator.html";
                  callServlet2(pageurl, "navigator");
                  pageurl=PSEdir+"atEntry.html";
                  callServlet(pageurl);
		} else if(subpage.equals("CURRENT")) {
		    pageurl = PSEdir + "atNavigator.html";
		    callServlet2(pageurl, "navigator");
		    pageurl = PSEdir + "atCurrent.html";
		    callServlet(pageurl);
                } else if(subpage.equals("PREVIOUS")) {
                    pageurl = PSEdir + "atNavigator.html";
                    callServlet2(pageurl, "navigator");
                    pageurl = PSEdir + "atPrevious.html";
                    callServlet(pageurl);
                } else if(subpage.equals("PROPERTY")) {
                    pageurl = PSEdir + "atNavigator.html";
                    callServlet2(pageurl, "navigator");
                    pageurl = PSEdir + "atProperty.html";
                    callServlet(pageurl);
		} else if(subpage.equals("VIEW")) {
                    pageurl = PSEdir + "atNavigator.html";
                    callServlet2(pageurl, "navigator");
                    pageurl = ATdir + "OEgauss.html";
                    callServlet(pageurl);
                }

                break;
          }

        case 104:
          {
              System.out.println("process 104");
                pageurl = "http://heechee.osc.edu:8002/PSE/PSEinfo.html";
              //pageurl=ServletDir+pageurl;
           callServlet2(pageurl, "help");
           break;
          }

        case 105:
          {
              System.out.println("process 105");
                pageurl = "http://heechee.osc.edu:8002/PSE/foundations/methodsFrame.html";
              //pageurl=ServletDir+pageurl;
           callServlet2(pageurl, "help");
           break;
          }

      case 999:
	{
        	// Funtion Not Implemented temporary page.
        	pageurl = PSEdir + "PSEunderConstruction.html";
        	callServlet(pageurl);
        	break;
	}

       	// Case 1000 functions as a back button
       	// go to the beginning of the toolkit chain 
	// Do we need a up one layer?
      	case 1000:
	{
		// CCM PSE restart
        	if(subpage.equals("")){
                        System.out.println("Here in blank");
			String uN = UserName.substring(0, UserName.indexOf("."));
			System.out.println(" in 1000 UserName = " + uN);
        		pageurl = PSEdir + "ccmNavigator.html";
        		callServlet2(pageurl, "navigator");
        		pageurl = ServletDir + "ccmUserPage?userContext="+uN;
        		callServlet(pageurl);
        		break;
		}
		// PD restart
        	else if(subpage.equals("A")){
                        System.out.println("Here in A");
        		pageurl = PSEdir + "pdNavigator.html";
        		callServlet2(pageurl, "navigator");
        		pageurl = PSEdir + "probDescEntry.html";
        		callServlet(pageurl);
        		break;
		}
		// CT restart
        	else if(subpage.equals("ctE")){
                        System.out.println("Here in ctE");
        		pageurl = PSEdir + "ctENavigator.html";
        		callServlet2(pageurl, "navigator");
        		pageurl = PSEdir + "ctEEntry.html";
        		callServlet(pageurl);
        		break;
		}
        	else if(subpage.equals("ctP")){
                        System.out.println("Here in ctP");
        		pageurl = PSEdir + "ctPNavigator.html";
        		callServlet2(pageurl, "navigator");
        		pageurl = PSEdir + "ctPEntry.html";
        		callServlet(pageurl);
        		break;
		}
		// AT restart
        	else if(subpage.equals("C")){
                        System.out.println("Here in C");
        		pageurl = PSEdir + "atNavigator.html";
        		callServlet2(pageurl, "navigator");
        		pageurl = PSEdir + "atEntry.html";
        		callServlet(pageurl);
        		break;
		}
	}
	//kenf - end of toolkit pages

      default: 
	{ System.out.println("Oops, unknown case "+currentPage);} 
      } 
      
      System.out.println("--- end of forwardForm");
     }


     public void callServlet(String pageurl) {

	  try {
            System.out.println(pageurl);
            docURL = new URL(pageurl);
            ac.showDocument(docURL, "GatewayHTML");
          } catch (Exception ee) {System.out.println("Really? "+ee);}
     }

	//kenf- callServlet2 - needs a target frame string

     public void callServlet2(String pageurl, String targ) {
        if (targ == null) targ = "GatewayHTML";
          try {
            System.out.println(pageurl);
            docURL = new URL(pageurl);
            ac.showDocument(docURL, targ);
          } catch (Exception ee) {System.out.println("Really? "+ee);}
     }
	//kenf - end of callServlet2

    public void setUserContext(String IorUrl, String UserName) {
      uc=null;

      /* connect to the master */

      System.out.println(IorUrl);
      try {
      java.net.URL url = new java.net.URL(IorUrl);       
      InputStream istream;
      String ref = "";

      System.out.println("open stream");   
      try {
       istream = url.openStream();
       BufferedReader in = new BufferedReader(new InputStreamReader(istream));
       ref = in.readLine();
       istream.close();
  
        
      System.out.println("read:"+ref);   
       try { 
        System.out.println("obj2str"); 
       org.omg.CORBA.Object MasterObj=orb.string_to_object(ref);
        if(MasterObj == null) {
          System.out.println("Master is null ??????");
        }
        else {
          System.out.println("MasterObj is OK");
        }
         
	 ws = WebFlowContextHelper.narrow(MasterObj);
        if(MasterObj == null) System.out.println("Oops: MasterObj is null!");
        System.out.println("Master narrowed");
     

       }catch(Exception e) {
         System.out.println("CORBA problem: "+e);
       }
      }
       catch(IOException e) { 
         System.out.println("stream problem: "+e);
      }
      }
      catch (Exception urle) {System.out.println("URL problem"+urle);}


      /* find the user context */

      org.omg.CORBA.Object[] SlaveServers = ws.toArray();
      for(int i=0; i<SlaveServers.length; i++) {
          System.out.println(i);
          WebFlow.BeanContextChild Something=null;
          Something =BeanContextChildHelper.narrow(SlaveServers[i]);
             if(Something.isWFServer()) {
               System.out.println("is a WebServer");            
               WebFlowContext sl=WebFlowContextHelper.narrow(SlaveServers[i]);
               String SlaveName = sl.getObjectID();
               if(SlaveName.indexOf(UserName)>-1) {
                     uc=sl;
                     setSlaves(rootname,uc);
	       }
              System.out.println("endif");
	     }
      }

      if(uc._non_existent()) System.out.println("Oops: cannot connect to the user context !!!!");
      System.out.println("setUserContext completed");
      IOR=orb.object_to_string(uc);

      /* now check if any slaves are running */
       org.omg.CORBA.Object[] SlaveServers1 = uc.toArray();
       if(SlaveServers1.length>0) {
         for(int i=0; i<SlaveServers1.length; i++){
           System.out.println(i);
          WebFlow.BeanContextChild Something=null;
          Something =BeanContextChildHelper.narrow(SlaveServers1[i]);
              System.out.println(Something.getObjectID()); 
             if(Something.isWFServer()) {  
               System.out.println("is a WeBFlow server");           
              WebFlowContext bcc=WebFlowContextHelper.narrow(SlaveServers1[i]);
              String SlaveName = bcc.getObjectID();

                for(int j=0; j<n; j++) {
	          if(SlaveName.indexOf(UserName+"./"+hostnames[j])>-1) {
                     WebFlowContext sl = WebFlowContextHelper.narrow(bcc);
                     setConnectedHost(hostnames[j]);
                     setSlaves(hostnames[j],sl);
	          }
		}
               System.out.println("for done");  
	     }
           System.out.println("isWFServer done");  
	 }
         System.out.println("for over childs done");
       }
    System.out.println("setUserContext completed");
    }


     // -------- utilities ---------------------------------------

          public String removeSpaces(String name){ 
          // if name contains spaces replace them by _
          String oldName = name; 
          while(oldName.indexOf(' ')>-1) {
            StringBuffer sb = new StringBuffer(oldName);
            int idx1=oldName.indexOf(' ');
            sb.setCharAt(idx1,'_');
            oldName=new String(sb); 
	   }
           String newName=oldName;
           return newName; 
          } 

          public String setShortName(String ContextName){
          // format ContextName for display
           String ShortName = ContextName;
           int idx=ShortName.lastIndexOf("/");
           ShortName = ShortName.substring(idx+1);
           return ShortName; 
	  }

      public boolean currentProject(){
          // what is the current project?
	  // return false if no current project
	  // WARNING: it operates on global variables 

          boolean x = false;   

          if(ProjectContextData==null) { 
                pageurl = ServletDir+"Error?where=currentProject";
                pageurl += "&what=noProjContextData";
          }
          else {
                ProjectName=ProjectContextData.getParam("Project");
                x=true; 
	  }      
        return x;
      }

      public boolean currentSession(){
          // what is the current session?
	  // return false if no current session
	  // WARNING: it operates on global variables 

          boolean x = false;   
          if(SessionContextData==null) { 
               pageurl = ServletDir+"Error?where=currentSession";
               pageurl += "&what=no+SessionContextData";
          }
          else {
               SessionName=SessionContextData.getParam("Session");
               x=true; 
	  }   
        return x;
      }

      public boolean sessionOfProject(){
          // is the SessionContextData consistent with the ProjectContextData?
	  // returns false if not consistent
	  // WARNING: it operates on global variables 

          boolean x = false;
          if(SessionContextData==null) {
             pageurl = ServletDir+"Error?where=sessionOfProject";
             pageurl += "&what=no+SessionContextData";
	  }
          else {
             String sname=SessionContextData.getParam("Session"); 
             if(SessionName.equals(sname)) {
               String pname=SessionContextData.getParam("Project");
               if(pname.equals(ProjectName)) {
                  x=true; 
	       }
               else {     
                  pageurl = ServletDir+"Error?where=sessionOfProject";
                  pageurl += "&what=wrong+project+name";
                  System.out.println("ProjectName="+ProjectName);
                  System.out.println("pname="+pname);
	       }
	     }
             else {
                pageurl = ServletDir+"Error?where=sessionOfProject";
                pageurl += "&what=wrong+session+context+name";
                System.out.println("SessionName "+SessionName);
                System.out.println("sname "+sname);
	     } 
	  }
          return x;
      }
      public boolean currentApplication(){
          // what is the current application?
	  // return false if no current application
	  // WARNING: it operates on global variables 

          boolean x = false; 
     
          if(ApplicationName!=null | ApplicationName.length()>0) {
            if(ApplicationContextData==null) {
             pageurl = ServletDir+"Error?where=currentApplication";
             pageurl += "&what=no+ApplicationContextData";
	    }
            else {   
	     if(ApplicationContextData.containsKey("Code")) {
               String Code=ApplicationContextData.getParam("Code");
                 if(Code.equals(ApplicationName)) { 
                   x=true; 
                 }
                 else {
                   pageurl = ServletDir+"Error?where=currentApplication";
                   pageurl += "&what=wrong+application+name";
                   System.out.println(Code+" "+ApplicationName);
		 }
	     }      
             else {
	       // no current application        
                pageurl = ServletDir+"PSEapplicationError";
                pageurl += "?Session="+SessionName;
                System.out.println("no Code entry in hashtable");  
	     }
	    }
	  }
          else {
	       // no current application        
                pageurl = ServletDir+"PSEapplicationError";
                pageurl += "?Session="+SessionName;
                System.out.println("application name not set");  
	  }
        return x;
      }



      public WebFlowContext selectContext(WebFlowContext root, String suffix,
                                          String name){
    
	   /* select context specified in HTMLform */
           Vector ContextList = makeListOfContexts(root,suffix);     
           Enumeration l = ContextList.elements();
           int numberOfElements = ContextList.size();

           WebFlowContext selectedContext = null; 
           
           if(numberOfElements>0) {
              while (l.hasMoreElements()){
                WebFlowContext c = (WebFlowContext)l.nextElement();
                String contextName = c.getObjectID();
	   	String tester = (String)HTMLform.get("contextName");
                if(tester.indexOf("/")>-1) {
      	   	 tester = tester.substring(tester.lastIndexOf("/")+1);
		}
      	   	String tester2 = contextName.substring(contextName.lastIndexOf("/")+1);
		// String tester2 = contextName;
		System.out.println("in selectContext = " + tester);
		System.out.println("in selectContext2 = " + tester2);
                if(tester.equals(tester2)) {
			System.out.println("in selectContext = " + tester);
                	selectedContext = c;
	        }
	      }
	   }
           else {
               pageurl = ServletDir + "PSE" + name + "Error";  
               callServlet(pageurl);
	   }
	   if(selectedContext == null) {
              pageurl = ServletDir+"PSE"+name+"Error1";
              callServlet(pageurl);
	   }
         return selectedContext;  
      }             

       /* candidate for context manager */
       public ContextData findContextData(WebFlowContext wfc) {
          ContextData wfcContextData=null;

          String ContextDataName = wfc.getObjectID()+"/ContextData";
          org.omg.CORBA.Object o = wfc.getKeyedChild(ContextDataName);
          if(o != null) {
          wfcContextData = ContextDataHelper.narrow(o); 
	  } else {System.out.println("Context data not found!");}

     
	  if(wfcContextData==null) {
            System.out.println("Context data not found!");
	  }
        return wfcContextData;
       }
 
    public void ReplaceProject(){ 
      ProjContextName = (String)HTMLform.get("ProjectContextName");
      ProjContextName=removeSpaces(ProjContextName);
      ProjectName=setShortName(ProjContextName);
      curDir = DDir+"USER/"+UserName+"/"+ProjectName;
      System.out.println(curDir);
      if(remotefile.exists(curDir)) {
          System.out.println("directory exists!");
          deleteProject();
          createNewProject();
      }
      else {
          System.out.println("new project");
          createNewProject();
      }
    }

   public void deleteProject() {
     System.out.println("Removing Project");
     ProjContextName = (String)HTMLform.get("ProjectContextName");
     System.out.println(ProjContextName);
     if(ProjContextName.indexOf(".PC")<0) ProjContextName+=".PC";
     HTMLform.put("contextName",ProjContextName); 

    try {
      ProjectContext = selectContext(uc,".PC","projectlist");
      rmChild(uc,ProjectName);
      curDir=getContextData(ProjectContext,"Directory");
      if(remotefile.rmdir(curDir))
        System.out.println("project deleted");
      else {
        System.out.println("deletion failed!");
      } 
      ProjectContext.removeMyself();
    }
    catch (Exception e) {System.out.println(e+ "while remove project"); 
    }
   }

   public void createNewProject() {

     ProjContextName = (String)HTMLform.get("ProjectContextName");

     ProjContextName=removeSpaces(ProjContextName);
     ProjectName=setShortName(ProjContextName);
     curDir = DDir+"USER/"+UserName+"/"+ProjectName;

     if(remotefile.mkdir(curDir)){
         ProjectName = ProjContextName;
         int idx=ProjectName.lastIndexOf("/");
         ProjectName = ProjectName.substring(idx+1);
         ProjContextName += ".PC";
         setContextData(uc,"Project",ProjContextName);

          	  // create a new ProjectContext
          try {
                 ProjectContext=WebFlowContextHelper
               		    .narrow(uc.addNewContext(ProjContextName)); 

          	  // add ContextData module to the newly created context
            	  ProjectContextData = ContextDataHelper
		       .narrow(ProjectContext.addNewModule("ContextData"));

          	 //  store Context name in the ContextData 
          	 //  ProjectName is fully qualified context name +.PC
          	 //  Project is what the user entered without spaces  
	
            	 setContextData(ProjectContext,"ProjectName",ProjContextName); 
            	 setContextData(ProjectContext,"Project",ProjectName); 
            	 setContextData(ProjectContext,"Directory",curDir); 
                 String ucChildren = getContextData(uc,"Children");
                 if(ucChildren.equals("")) {
		     setContextData(uc,"Children",ProjContextName);
		     //setContextData(uc,"Children",ProjectName);
		 }
                 else {
		setContextData(uc,"Children",ucChildren+"+"+ProjContextName);
                //setContextData(uc,"Children",ucChildren+"+"+ProjectName);
		 }       

	     } catch (Exception e) { 
                System.out.println(e+" while createNewProject");
	     }

     }
      else {
        pageurl = ServletDir + "PSEprojectError2?Name="+ProjectName;
        System.out.println("NewProject: already exists = " + ProjContextName);
        callServlet(pageurl); 
      }

   }

      	public void createNewSession() { 

          System.out.println("start create a new session");
          SessionContextName = (String)HTMLform.get("SessionContextName");

          SessionContextName=removeSpaces(SessionContextName);   
          SessionName=setShortName(SessionContextName);

          System.out.println("SessionName: "+SessionName); 
          // create directory for this session
          curDir=getContextData(ProjectContext,"Directory");
          curDir += "/"+SessionName;
          System.out.println("curDir="+curDir);
          remotefile.test(); 
          if(remotefile.mkdir(curDir)) {  

 	   // make it easier to identify an SessionContext
          SessionContextName += ".SC";

          // verify that this session name does not already exist 
          // to be done

          // set the project as the current one
          setContextData(uc,"Session",SessionContextName);

          if(ProjectContext==null) {
             System.out.println("        ?%$#@*&=^*!@#$%");
             System.out.println(" NO PROJECT CONTEXT !!!");
	  } 
	  
          // create a new SessionContext
          try {
          SessionContext=WebFlowContextHelper
               .narrow(ProjectContext.addNewContext(SessionContextName)); 

          //  add ContextData module to newly created context
          SessionContextData = 
          ContextDataHelper.narrow(SessionContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  SessionName is fully qualified context name +.SC
          //  Session is what the user entered without spaces (shortName)
          //  Project is the current project (shortName)  

          setContextData(SessionContext,"SessionName", SessionContextName); 
          setContextData(SessionContext,"Session",SessionName); 
          setContextData(SessionContext,"Project",ProjectName); 
	  String prChildren = getContextData(ProjectContext,"Children");
          if(prChildren.equals("")) {
             setContextData(ProjectContext,"Children",SessionContextName);
	  }
          else {
            setContextData(ProjectContext,"Children",prChildren+"+"+SessionContextName);
	  }         
         }  catch (Exception e) { System.out.println(e);}

          // start session date

          currentDate = new Date();
          time = currentDate.getTime(); 
          String timestring = (new Long(time).toString());
          
          setContextData(SessionContext,"Time",timestring);  
          setContextData(SessionContext,"LastTime",timestring);  
          setContextData(SessionContext,"Directory",curDir);  

//         pageurl=ServletDir+"PSEapplicationlist?Project="+ProjectName;
//         pageurl+="&Session="+SessionName;
	  pageurl = PSEdir + "ctPNavigator.html";
          callServlet2(pageurl, "navigator");
          pageurl=PSEdir+"ctPEntry.html";           
          callServlet(pageurl); 
          } else {
           System.out.println("NewSession: already exists");
           pageurl = ServletDir+"PSEsessionError2?Name="+SessionName;
           callServlet(pageurl);
	  }
        System.out.println("session created"); 
      }


    public void cloneSession(WebFlowContext oldSession) {
        createNewSession();
        String oldDir = getContextData(oldSession,"Directory");
        String newDir = getContextData(SessionContext,"Directory");
        System.out.println(oldDir);
        System.out.println(newDir); 
        remotefile.copy(oldDir+"/ContextData.txt", newDir+"/ContextData.txt"); 
        setContextData(SessionContext,"SessionName", SessionContextName); 
        setContextData(SessionContext,"Session",SessionName); 
        setContextData(SessionContext,"Project",ProjectName);
        restoreChildContexts(SessionContext);         
    }

    public void restoreChildContexts(WebFlowContext c) {
    System.out.println("-----> Restore Child Context: "+c.getObjectID());
    System.out.println("Restore Child Context: "+c.getObjectID());
    String cc = getContextData(c,"Children");
    System.out.println("Cdata: "+cc);
    StringTokenizer ptok = new StringTokenizer(cc,"+");
      if(ptok.countTokens()>0) {
	  while(ptok.hasMoreTokens()) {
	      try {
                 String Cname = ptok.nextToken();
                 System.out.println("nextToken: "+Cname);
                 WebFlowContext p=WebFlowContextHelper.narrow(
                            c.addNewContext(Cname));
                 System.out.println("added context: "+p.getObjectID());
                 ContextData cd = ContextDataHelper.narrow(
                            p.addNewModule("ContextData"));
                 saveContext.restoreContextData(p,DDir); 
                 restoreChildContexts(p);
	      }
              catch (Exception e) {
                  System.out.print("cannot create context "+e);
                  }
	  } 
      }  
    }

      	public void createNewApplication() { 

          	appl="";
          	appl = (String)HTMLform.get("application");
         	ApplContextName = appl;

          	ApplContextName=removeSpaces(ApplContextName);   
          	ApplicationName=setShortName(ApplContextName);
	
	  	// create directory for this application
          	curDir=getContextData(SessionContext,"Directory");
          	curDir += "/"+ApplicationName;
          	if(remotefile.mkdir(curDir)) { 
 	   		// make it easier to identify an ApplicationContext
          		ApplContextName += ".AC";
		
          		// verify that this session name does not already exist 
          		// to be done
		
          		if(ProjectContext==null) {
             			System.out.println("        ?%$#@*&=^*!@#$%");
             			System.out.println(" NO PROJECT CONTEXT !!!");
	  		} 

          if(SessionContext==null) {
             System.out.println("        ?%$#@*&=^*!@#$%");
             System.out.println(" NO SESSION CONTEXT !!!");
	  } 

          // create a new ApplContext
          try {
          ApplContext=WebFlowContextHelper
               .narrow(SessionContext.addNewContext(ApplContextName)); 

          ApplContextName = ApplContext.getObjectID();
          //  add ContextData module to newly created context
          ApplicationContextData = 
          ContextDataHelper.narrow(ApplContext.addNewModule("ContextData"));
          //  store Context name in the ContextData 
          //  ApplicationName is fully qualified context name + .AC
          //  Application is application name (shortName)
          //  ApplDesc is application descriptor (.xml) as received
          //  Session is the current session (shortName)
          //  Project is the current project (shortName)  

          setContextData(ApplContext,"ApplicationName",ApplContextName);
          setContextData(ApplContext,"Application",ApplicationName);
          setContextData(ApplContext,"ApplDesc",appl);
          setContextData(ApplContext,"Session",SessionName);
          setContextData(ApplContext,"Project",ProjectName);
          setContextData(ApplContext,"Directory",curDir);
	  String sChildren = getContextData(SessionContext,"Children");
          if(sChildren.equals("")) {
             setContextData(SessionContext,"Children",ApplContextName);
	  }
          else {
            setContextData(SessionContext,"Children",sChildren+"+"+ApplContextName);
	  }         
	  } catch (Exception e) { System.out.println(e);}

//        pageurl=ServletDir+"PSEinput?appl="+ApplicationName;
//        pageurl+="&Project="+ProjectName; 
//        pageurl+="&Session="+SessionName;

          /* attach event "submit" fired by CommandLine of XmlParser*/
//          ApplContext.attachPushEvent(oxml,"submit",os,"submit");
          } else {
           System.out.println("NewApplication: already exists");
           pageurl = ServletDir+"PSEapplicationError2?Name="+SessionName;
           callServlet(pageurl);
	  	} 
      	}

     	public void setContextData(WebFlowContext c, String name, String value){
	    //System.out.println("start setContextData");         
         	ContextData cd = findContextData(c);
		//System.out.println("setParam");
		//System.out.println("name="+name);
		//System.out.println("value="+value);  
         	cd.setParam(name,value);
		//System.out.println("setParam done");  
		//System.out.println(c.getObjectID());

         	//find the Session Context and set last updated time
         	String session=""; 
         	String contextName = c.getObjectID(); 
         	int idx = contextName.indexOf(".SC");
         	if(idx>-1) {
           		session = contextName.substring(0,idx+3);
           		WebFlowContext s = WebFlowContextHelper.narrow(uc.getContext(session));
           		if(s==null) System.out.println("session is null"); 
			//	else {System.out.println("session OK!");}
           		ContextData sd = findContextData(s); 
           		time = (new Date()).getTime();
           		String timestring = (new Long(time).toString());
           		sd.setParam("LastTime",timestring);
	 	}
		// System.out.println("saveContextData");
         	saveContext.saveContextData(c);
                //System.out.println("restoreContextData");
         	saveContext.restoreContextData(c,DDir);
                //System.out.println("done"); 
     	}    

     	public String getContextData(WebFlowContext c, String name) {
          	ContextData cd = findContextData(c);
          	String value = cd.getParam(name); 
          	return value;
     	}

     	public void archiveProject(){
     	}
	
     	public void archiveSession(){
     	}

       	public FileBrowser getFileBrowser(){ 
		return filebrowser; 
	}
       
	public RemoteFile getRemoteFile(){ 
		return remotefile;
	}

       public void rmChild(WebFlowContext c, String contextName) {
          System.out.println("rmChild: "+contextName);
          String children = getContextData(c,"Children");
          System.out.println("children: "+children);
          int idx=children.indexOf(contextName);
          int l=contextName.length();
          String newChildren=""; 
          if(idx>0) newChildren = children.substring(0,idx-1);
          newChildren += children.substring(idx+l);
          if(newChildren.startsWith("+")) newChildren=newChildren.substring(1);
          System.out.println("new: "+newChildren);
          setContextData(c, "Children", newChildren); 
       }

       public void setContextLabel(String s) {
        int idx=s.indexOf("/");
        if(idx<0) {
          System.out.println("Oh, shit! "+s);
        }
        else {  
          String contextName = s.substring(idx+1);
          contextLabel.setText(contextName);   
	}
       }

       public void deleteProjectJobs(WebFlowContext pContext) {
         String pName = pContext.getObjectID();
         int njobs = jobContexts.size();
         System.out.println("delete "+pName);
         Vector aa=new Vector();
         Vector bb=new Vector();

         for(int i=0;i<njobs;i++) {
           String jobName = (String)jobContexts.elementAt(i);
           if(jobName.startsWith(pName)) {
             System.out.println(jobName+" to be deleted");
             //jobContexts.removeElementAt(i);
             //jobVector.removeElementAt(i);
	   }
           else {
             System.out.println(jobName+" stays!");
             aa.addElement(jobVector.elementAt(i));
             bb.addElement(jobName);
	   }    
	 }
         System.out.println("end of loop");
         jobVector=aa;
         jobContexts=bb;
         int mjobs = aa.size();
         System.out.println("old="+njobs+" "+"new="+mjobs);
         String[] a=null;
         String[] b=null;
         if(mjobs<njobs) {
	     if(mjobs>0) {
               a = new String[mjobs];
               b = new String[mjobs];
	       for(int i=0; i<mjobs; i++) {
               a[i]=(String)jobVector.elementAt(i);  
               b[i]=(String)jobContexts.elementAt(i);  
	       }
	     }
             else {
               a = new String[1];
               b = new String[1];
               a[0]="none";   
               b[0]="none";
	     }   
           saveContext.serializeArray(a,userDir+"/jobVector");  
           saveContext.serializeArray(b,userDir+"/jobContexts");  
           cards[rootCard].JobStatus.refreshJobPanel(jobVector);
           cards[rootCard].showJobTab();
	 }
        }

   }


