@echo off

if "%JAVA_HOME%" == "" goto error

echo.
echo Xalan-J Build
echo -------------

rem Update SERVLET to point to JAR containing javax.servlet and javax.servlet.http packages.
set SERVLET=\jswdk-1.0.1\lib\servlet.jar

set ANT=ant.jar
set JAVAC=%JAVA_HOME%\lib\tools.jar
set XERCES=xerces.jar
set JAXP=jaxp.jar
set BSF=bsf.jar
set BSFENGINES=bsfengines.jar
set DOCGENERATOR=xdocs\stylebook-1.0-b2.jar
set DOCLET=xdocs\xalanjdoc.jar

set HOLDINGPATH=%CLASSPATH%

rem DOCLET must be on system CLASSPATH for javadocs task to work. Just including it in
rem -classpath arg for java or javadoc call doesn't work....

set CLASSPATH=%ANT%;%JAVAC%;%XERCES%;%JAXP%;%BSF%;%BSFENGINES%;%SERVLET%;%DOCGENERATOR%;%DOCLET%;%CLASSPATH%

echo.
echo Building with classpath %CLASSPATH%

echo.
echo Starting Ant...

%JAVA_HOME%\bin\java.exe -Dant.home="%ANT_HOME%" -classpath "%CLASSPATH%" org.apache.tools.ant.Main %1 %2 %3 %4 %5

goto end

:error

echo "ERROR: JAVA_HOME not found in your environment."
echo.
echo "Please, set the JAVA_HOME environment variable to match the"
echo "root directory of the Java Virtual Machine you want to use."

:end

set CLASSPATH=%HOLDINGPATH%
set HOLDINGPATH=
set XERCES=
set JAXP=
set BSF=
set BSFENGINES=
set SERVLET=
set DOCGENERATOR=
set DOCLET=
set ANT=
set XML=
set ANT_HOME=
set JAVAC=